guiDraw = {};

function guiDraw:open(self)	
	g_currentMission.guiMenue.clickAreas = {};
	local overlay = g_currentMission.guiMenue.overlays;
	local posX = g_currentMission.guiMenue.default.posX;
	local posY = g_currentMission.guiMenue.default.posY;
	local horizontal = overlay["buttonDragDrop"].width;
	local vertical =  overlay["buttonDragDrop"].height;
	local horizontalDistance = horizontal/2;
	local verticalDistance = vertical/2;
	local horizontalTxtDistance = g_currentMission.guiMenue.default.horizontalTxtDistance;
	local verticalTxtDistance = g_currentMission.guiMenue.default.verticalTxtDistance;
	local disableClickAreas = g_currentMission.guiMenue.dragDrop.on or g_currentMission.guiMenue.pullDown.open;
	local disableTxtColor = g_currentMission.guiMenue.pullDown.open or string.len(g_currentMission.guiMenue.helpText.txt) > 0;
	local infoTxt = "";
	local notModSave, notModeSaveName = guiDraw:foundModNotSave(self);	
	local modTable = g_currentMission.guiMenue.mod;
	local guiModTable = g_currentMission.guiMenue.modTable[modTable];
	local modMenueActive = guiModTable.isGenerate;
	local modMenueHidden = guiModTable.isHidden;
	if g_currentMission.guiMenue.dragDrop.on and g_currentMission.guiMenue.dragDrop.whatClick == "guiMasterMenue" then
		g_currentMission.guiMenue.master:stopPullDown(self, "Draw open DragDrop");		
		--disableClickAreas = true;
		g_currentMission.guiMenue.default.posX = g_currentMission.guiMenue.mouseCursor.posX; --(overlay["buttonDragDrop"].width/2);
		g_currentMission.guiMenue.default.posY = g_currentMission.guiMenue.mouseCursor.posY-g_currentMission.guiMenue.default.height;
		guiDragDrop:getWarning(self, g_currentMission.guiMenue.default.posX, g_currentMission.guiMenue.default.posY, g_currentMission.guiMenue.default.width+(horizontal/1.5), 0+overlay["groundSlave"].height+overlay["groundInfoBox"].height, "guiMasterMenue")
	end;
	if g_currentMission.guiMenue.on then		
		local pageType = g_currentMission.guiMenue.guiSetGetMenue:getPageType(modTable);
		if pageType == nil then guiModTable.lastOpenPage = {masterPage=1, slavePage=1, pageSide=1};end; --reset is problem	for safety	
		local masterPage = guiModTable.lastOpenPage.masterPage;
		local slavePage = guiModTable.lastOpenPage.slavePage;
		local pageSide = guiModTable.lastOpenPage.pageSide;	
		
		--is problem with master/slave/side page for safety
		if pageType ~= nil then
			if guiModTable.page[masterPage] == nil then masterPage = 1;guiModTable.lastOpenPage.masterPage = 1;end;
			if pageType == "modSlavePageSide" then				
				if guiModTable.page[masterPage].page[slavePage] == nil then slavePage = 1;guiModTable.lastOpenPage.slavePage = 1;end;
				if guiModTable.page[masterPage].page[slavePage].side[pageSide] == nil then pageSide = 1;guiModTable.lastOpenPage.pageSide = 1;end;
			else
				if guiModTable.page[masterPage].side[pageSide] == nil then pageSide = 1;guiModTable.lastOpenPage.pageSide = 1;end;
			end;
		end;		
		--is problem with master/slave/side page for safety
		
		local txt = "";
		local optiSize = 0;
		local txtLength = 0;
		local txtHeight = 0;
		-----------------------------------Master Gui Menue-----------------------------------		
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundMaster"], posX, posY);
		overlay["groundMaster"]:render();
		if g_currentMission.guiMenue.viewPage > 0 then
			g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundSlave"], posX, posY-overlay["groundSlave"].height);
			overlay["groundSlave"]:render();			
		end;		
		guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["groundMaster"], 0.001, false, true, false, false, g_currentMission.guiMenue.default.groundLineColor);
		
		--info txt box
		if g_currentMission.guiMenue.viewPage == 1 or g_currentMission.guiMenue.viewPage == 2 then	
			if modMenueActive and not modMenueHidden then
				g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundInfoBox"], posX, posY-(overlay["groundSlave"].height)-overlay["groundInfoBox"].height, overlay["groundInfoBox"].width, (vertical*4)+horizontalTxtDistance);
				overlay["groundInfoBox"]:render();
				guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["groundInfoBox"], 0.0008, true, false, false, false, g_currentMission.guiMenue.default.groundLineColor);
			else
				g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundInfoBox"], posX, posY-overlay["groundInfoBox"].height, overlay["groundInfoBox"].width, (vertical*4)+horizontalTxtDistance);
			end;
		end;
		--info txt box
		
		--dragDrop,save,zoom and close
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonDragDrop"], posX, posY+overlay["groundMaster"].height-(vertical));
		if g_currentMission.guiMenue.dragDrop.on or g_currentMission.guiMenue.pullDown.open then
			g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonDragDrop"], g_currentMission.guiMenue.guiSetGet.colors["red"]);
		else
			g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonDragDrop"], g_currentMission.guiMenue.guiSetGet.colors["green"]);
			if not disableClickAreas then			
				guiDraw:setClickAreas(overlay["buttonDragDrop"].x, overlay["buttonDragDrop"].x+(horizontal), overlay["buttonDragDrop"].y, overlay["buttonDragDrop"].y+(vertical), "dragDrop", "guiMasterMenue", "", tostring(infoTxt), nil, nil, nil, nil ,nil ,nil, masterPage, slavePage, pageSide, pageType);
			end;
		end;
		overlay["buttonDragDrop"]:render();
		
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonSmallView"], posX+overlay["groundMaster"].width-(horizontal*5), posY+overlay["groundMaster"].height-(vertical));
		if g_currentMission.guiMenue.viewPage > 0 then
			g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonSmallView"], g_currentMission.guiMenue.guiSetGet.colors["green"]);
		else
			g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonSmallView"], g_currentMission.guiMenue.guiSetGet.colors["red"]);
		end;
		if not disableClickAreas then
			guiDraw:setClickAreas(overlay["buttonSmallView"].x, overlay["buttonSmallView"].x+(horizontal), overlay["buttonSmallView"].y, overlay["buttonSmallView"].y+(vertical), "smallView", "guiMasterMenue", "", tostring(infoTxt), nil, nil, nil, nil ,nil ,nil, masterPage, slavePage, pageSide, pageType);
		end;
		overlay["buttonSmallView"]:render();
		
		infoTxt = "!! Default value 3.4 (".. tostring(g_currentMission.guiMenue.default.zoomOutInTemp).. ") !!\n!! New value is only temporary, for game session !!";
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonZoomIn"], posX+overlay["groundMaster"].width-(horizontal*4), posY+overlay["groundMaster"].height-(vertical));
		if g_currentMission.guiMenue.default.zoomOutInTemp <= g_currentMission.guiMenue.default.minZoomOutInTemp then g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonZoomIn"], g_currentMission.guiMenue.guiSetGet.colors["red"]);infoTxt = "!! Minimum ZoomIn reached !!\n!! value is only temporary, for game session !!"else
		g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonZoomIn"], g_currentMission.guiMenue.guiSetGet.colors["green"]);end;
		if not disableClickAreas then
			guiDraw:setClickAreas(overlay["buttonZoomIn"].x, overlay["buttonZoomIn"].x+(horizontal), overlay["buttonZoomIn"].y, overlay["buttonZoomIn"].y+(vertical), "zoomIn", "guiMasterMenue", "", tostring(infoTxt), nil, nil, nil ,nil ,nil ,nil, masterPage, slavePage, pageSide, pageType);
		end;
		overlay["buttonZoomIn"]:render();		
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonZoomOut"], posX+overlay["groundMaster"].width-(horizontal*3), posY+overlay["groundMaster"].height-(vertical));
		if g_currentMission.guiMenue.default.zoomOutInTemp >= g_currentMission.guiMenue.default.maxZoomOutInTemp then g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonZoomOut"], g_currentMission.guiMenue.guiSetGet.colors["red"]);infoTxt = "!! Maximum ZoomOut reached !!\n!! value is only temporary, for game session !!";else
		g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonZoomOut"], g_currentMission.guiMenue.guiSetGet.colors["green"]);end;
		if not disableClickAreas then
			guiDraw:setClickAreas(overlay["buttonZoomOut"].x, overlay["buttonZoomOut"].x+(horizontal), overlay["buttonZoomOut"].y, overlay["buttonZoomOut"].y+(vertical), "zoomOut", "guiMasterMenue", "", tostring(infoTxt), nil, nil, nil ,nil ,nil ,nil, masterPage, slavePage, pageSide, pageType);
		end;
		overlay["buttonZoomOut"]:render();
		infoTxt = "";
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonSave"], posX+overlay["groundMaster"].width-(horizontal*2), posY+overlay["groundMaster"].height-(vertical));
		if notModSave > 0 then
			g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonSave"], g_currentMission.guiMenue.guiSetGet.colors["red"]);
			infoTxt = tostring(notModSave).. " Mod to saved\n".. tostring(notModeSaveName);
		else
			g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonSave"], g_currentMission.guiMenue.guiSetGet.colors["green"]);
		end;		
		if not disableClickAreas then			
			guiDraw:setClickAreas(overlay["buttonSave"].x, overlay["buttonSave"].x+(horizontal), overlay["buttonSave"].y, overlay["buttonSave"].y+(vertical), "save", "guiMasterMenue", "", tostring(infoTxt), nil, nil, nil ,nil ,nil ,nil,  masterPage, slavePage, pageSide, pageType);
		end;		
		overlay["buttonSave"]:render();
		infoTxt = "";
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonClose"], posX+overlay["groundMaster"].width-(horizontal), posY+overlay["groundMaster"].height-(vertical));
		if not disableClickAreas then
			if notModSave > 0 then infoTxt = "!! ".. tostring(notModSave).. " Mod not saved !!\n".. tostring(notModeSaveName);end;			
			--infoTxt = "!! ".. tostring(notModSave).. " Mod not saved ggggggggggggg rrrrrrrrrrrrrrrrrr tttttttttttttt eeeeeeeee uuuuuuuuuuu öööööööööööööö kkkkkkkkkkkkkk wwwwwwwwwwww!!" --test
			guiDraw:setClickAreas(overlay["buttonClose"].x, overlay["buttonClose"].x+(horizontal), overlay["buttonClose"].y, overlay["buttonClose"].y+(vertical), "close", "guiMasterMenue", "", tostring(infoTxt), nil, nil, nil , nil, nil, nil, masterPage, slavePage, pageSide, pageType);
		end;		
		overlay["buttonClose"]:render();
		infoTxt = "";
		--dragDrop,save,zoom and close		
		
		--copyright	GuiMenue
		if g_currentMission.guiMenue.guiSetGet:runsTimer("15sec", true) then
			txt = tostring(guiMenue.metadata.title).. " ".. tostring(guiModTable.guiMenueVersion).. tostring(guiMenue.metadata.author);
			optiSize = guiDraw:getOptimalSize(overlay["groundMaster"].width-horizontalTxtDistance-(horizontal*5), txt, g_currentMission.guiMenue.default.size-0.001);
			txtLength = getTextWidth(optiSize, tostring(txt));
			txtHeight = getTextHeight(optiSize, tostring(txt));
			setTextColor(unpack(g_currentMission.guiMenue.guiSetGet.colors["gray"]));
			renderText(posX+overlay["groundMaster"].width-txtLength-horizontalTxtDistance-(horizontal*5), posY+overlay["groundMaster"].height-txtHeight, optiSize, txt);
		end;
		--copyright	GuiMenue		
		
		-----------button 1-----------
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonBlank"], posX+(horizontal), posY+overlay["groundMaster"].height-(vertical*2)-(verticalDistance), overlay["groundMaster"].width-(horizontal*2)-(horizontalDistance*2));
		--g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonBlank"], posX+(horizontal), posY+overlay["groundMaster"].height-(vertical*2)-(verticalDistance), overlay["groundMaster"].width/2-(horizontal*2)-(horizontalDistance));
		overlay["buttonBlank"]:render();
		guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["buttonBlank"], 0.001, true, true, true ,true, g_currentMission.guiMenue.default.lineBorderColor);		
		g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["groundPushButton"], g_currentMission.guiMenue.default.groundPushButtonColor);
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundPushButton"], overlay["buttonBlank"].x+overlay["buttonBlank"].width, overlay["buttonBlank"].y, horizontal, vertical);
		overlay["groundPushButton"]:render();
		if #g_currentMission.guiMenue.modTable > 1 then 
			local buttonType = g_currentMission.guiMenue.default.buttonType[2];
			guiDraw:setButtonType(self, overlay[buttonType], {x=overlay["buttonBlank"].x, y=overlay["buttonBlank"].y, width=overlay["buttonBlank"].width});
			if not g_currentMission.guiMenue.dragDrop.on then
				guiDraw:setClickAreas(overlay[buttonType].x, overlay[buttonType].x+overlay[buttonType].width, overlay[buttonType].y, overlay[buttonType].y+overlay[buttonType].height, "pullDownMods", "guiMasterMenue", "", "", {x=overlay["buttonBlank"].x,y=overlay["buttonBlank"].y,width=overlay["buttonBlank"].width}, 1, 1, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
			end;
		end;
		
		--txt over Button 1
		setTextBold(true);		
		setTextColor(unpack(g_currentMission.guiMenue.default.textTitleColor));
		txt = tostring("Mods: ").. tostring(modTable).. "/".. tostring(#g_currentMission.guiMenue.modTable)
		renderText(overlay["buttonBlank"].x+horizontalTxtDistance, overlay["buttonBlank"].y+vertical+verticalTxtDistance, g_currentMission.guiMenue.default.size, txt);
		setTextBold(false);			
		--txt over Button 1
		
		--txt at Button 1			
		setTextColor(unpack(g_currentMission.guiMenue.default.textColor));
		txt = tostring(guiModTable.name);
		optiSize = guiDraw:getOptimalSize(overlay["buttonBlank"].width-(overlay["buttonEmpty"].width)-(horizontalTxtDistance), txt, g_currentMission.guiMenue.default.size);	
		txtHeight = getTextHeight(optiSize, tostring(txt));
		setTextBold(true);
		if not modMenueActive or modMenueHidden then setTextBold(false);end;
		renderText(overlay["buttonBlank"].x+horizontalTxtDistance, overlay["buttonBlank"].y+(overlay["buttonBlank"].height/2)-(txtHeight/2)+verticalTxtDistance, optiSize, txt);
		setTextBold(false);
		if not modMenueActive or modMenueHidden then
			txtLength = string.len(tostring(txt));
			txt = "";			
			for a=1, txtLength do
				txt = txt.. "-";
			end;			
			setTextBold(true);
			renderText(overlay["buttonBlank"].x+horizontalTxtDistance, overlay["buttonBlank"].y+(overlay["buttonBlank"].height/2)-(txtHeight/2)+verticalTxtDistance, optiSize, txt);
			setTextBold(false);
		end;
		--txt at Button 1				
		-----------button 1-----------		
						
		-----------button 2-----------		
		if modMenueActive and not modMenueHidden then
			if guiModTable.page ~= nil and #guiModTable.page > 0 then 
				g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonBlank"], posX+(horizontal), posY+overlay["groundMaster"].height-(vertical*4)-(verticalDistance)-(txtHeight/4), overlay["groundMaster"].width/2-(horizontal*2)-(horizontalDistance));
				overlay["buttonBlank"]:render();
				guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["buttonBlank"], 0.001, true, true, true, true, nil);
				g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["groundPushButton"], g_currentMission.guiMenue.default.groundPushButtonColor);
				g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundPushButton"], overlay["buttonBlank"].x+overlay["buttonBlank"].width, overlay["buttonBlank"].y, horizontal, vertical);
				overlay["groundPushButton"]:render();			
				--local buttonTypeColor = g_currentMission.guiMenue.guiSetGet.colors["darkGreen"];
				local buttonType = g_currentMission.guiMenue.default.buttonType[2]			
				guiDraw:setButtonType(self, overlay[buttonType], {x=overlay["buttonBlank"].x, y=overlay["buttonBlank"].y, width=overlay["buttonBlank"].width});
				if not g_currentMission.guiMenue.dragDrop.on then
					guiDraw:setClickAreas(overlay[buttonType].x, overlay[buttonType].x+overlay[buttonType].width, overlay[buttonType].y, overlay[buttonType].y+overlay[buttonType].height, "pullDownModMasterPage", "guiMasterMenue", "", "", {x=overlay["buttonBlank"].x,y=overlay["buttonBlank"].y,width=overlay["buttonBlank"].width}, 1, 2, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
				end;
				setTextColor(unpack(g_currentMission.guiMenue.default.textTitleModColor));	
				setTextBold(true);
				if (g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType == "pullDownMods") then setTextColor(unpack(g_currentMission.guiMenue.default.textColor));end; 
				renderText(overlay["buttonBlank"].x+horizontalTxtDistance, overlay["buttonBlank"].y+vertical+verticalTxtDistance, g_currentMission.guiMenue.default.size, tostring("Mod Master Page: ").. tostring(masterPage).. "/".. tostring(#guiModTable.page));
				setTextBold(false);
				setTextColor(unpack(g_currentMission.guiMenue.default.textColor));
				txt = tostring(guiModTable.page[masterPage].name);
				optiSize = guiDraw:getOptimalSize(overlay["buttonBlank"].width-(overlay["buttonEmpty"].width)-horizontalTxtDistance, txt, g_currentMission.guiMenue.default.size);	
				txtHeight = getTextHeight(optiSize, tostring(txt));
				setTextBold(true);
				renderText(overlay["buttonBlank"].x+horizontalTxtDistance, overlay["buttonBlank"].y+(overlay["buttonBlank"].height/2)-(txtHeight/2)+verticalTxtDistance, optiSize, txt);
				setTextBold(false);			
			end;
		end;		
		-----------button 2-----------	
		
		-----------button 3-----------
		if modMenueActive and not modMenueHidden then
			if guiModTable.page[masterPage] ~= nil and guiModTable.page[masterPage].page ~= nil and #guiModTable.page[masterPage].page > 0 then 
				g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonBlank"], posX+(overlay["groundMaster"].width/2)+(horizontalDistance), posY+overlay["groundMaster"].height-(vertical*4)-(verticalDistance)-(txtHeight/4), overlay["groundMaster"].width/2-(horizontal*2)-(horizontalDistance));
				overlay["buttonBlank"]:render();
				guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["buttonBlank"], 0.001, true, true, true, true, nil);
				g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["groundPushButton"], g_currentMission.guiMenue.default.groundPushButtonColor);
				g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundPushButton"], overlay["buttonBlank"].x+overlay["buttonBlank"].width, overlay["buttonBlank"].y, horizontal, vertical);
				overlay["groundPushButton"]:render();			
				local buttonType = g_currentMission.guiMenue.default.buttonType[2]			
				guiDraw:setButtonType(self, overlay[buttonType], {x=overlay["buttonBlank"].x, y=overlay["buttonBlank"].y, width=overlay["buttonBlank"].width});				
				if not g_currentMission.guiMenue.dragDrop.on then
					guiDraw:setClickAreas(overlay[buttonType].x, overlay[buttonType].x+overlay[buttonType].width, overlay[buttonType].y, overlay[buttonType].y+overlay[buttonType].height, "pullDownModSlavePage", "guiMasterMenue", "", "", {x=overlay["buttonBlank"].x,y=overlay["buttonBlank"].y,width=overlay["buttonBlank"].width}, 1, 3, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
				end;
				setTextColor(unpack(g_currentMission.guiMenue.default.textTitleModColor));
				setTextBold(true);
				if (g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType == "pullDownMods") then setTextColor(unpack(g_currentMission.guiMenue.default.textColor));end; 
				renderText(overlay["buttonBlank"].x+horizontalTxtDistance, overlay["buttonBlank"].y+vertical+verticalTxtDistance, g_currentMission.guiMenue.default.size, tostring("Mod Slave Page: ").. tostring(slavePage).. "/".. tostring(#guiModTable.page[masterPage].page));
				setTextBold(false);
				
				setTextColor(unpack(g_currentMission.guiMenue.default.textColor));
				txt = tostring(guiModTable.page[masterPage].page[slavePage].name);
				optiSize = guiDraw:getOptimalSize(overlay["buttonBlank"].width-(overlay["buttonEmpty"].width)-horizontalTxtDistance, txt, g_currentMission.guiMenue.default.size);	
				txtHeight = getTextHeight(optiSize, tostring(txt));
				setTextBold(true);
				renderText(overlay["buttonBlank"].x+horizontalTxtDistance, overlay["buttonBlank"].y+(overlay["buttonBlank"].height/2)-(txtHeight/2)+verticalTxtDistance, optiSize, txt);
				setTextBold(false)
			end;
		end;	
		-----------button 3-----------
		
		--copyright Info not uptodate/disabled GuiMenue for a Mod		
		if not modMenueActive or modMenueHidden or g_currentMission.guiMenue.guiSetGet:runsTimer("15sec", true) and not guiModTable.isUpToDate then
			txt = tostring(guiMenue.metadata.title).. "  ! Not UpToDate (info to modders) !\nMod used Version ".. tostring(guiModTable.guiMenueVersion).. "\nCurrent Version "..tostring(g_currentMission.guiMenue.script.version);
			if not modMenueActive and not modMenueHidden then txt = "! Gui Menue is Disabled in the Mod ! Not more Uptodate (info to modders)\nMod used Version ".. tostring(guiModTable.guiMenueVersion).. "\nCurrent Version "..tostring(g_currentMission.guiMenue.script.version);end;
			if modMenueHidden then txt = "! Gui Menue is Disabled !\nApp for MultiOverlayV3 Hud not found (! deinstall !)";end;
			if string.len(guiModTable.errorTxt) > 0 then txt = "! Gui Menue is Disabled for this Mod !\n".. tostring(guiModTable.errorTxt);end;
			if string.len(g_currentMission.guiMenue.infoText.txt) == 0 then g_currentMission.guiMenue.infoText.txt = txt;end;			
		end;
		--copyright Info not uptodate/disabled GuiMenue for a Mod
		--copyright Mod Version/Author		
		txt = tostring(guiModTable.version).. tostring(guiModTable.author);
		if string.len(txt) > 2 and not g_currentMission.guiMenue.pullDown.open or ((string.len(txt) > 2 and g_currentMission.guiMenue.pullDown.open and (not g_currentMission.guiMenue.pullDown.buttonType == "pullDownModMasterPage" or not g_currentMission.guiMenue.pullDown.buttonType == "pullDownModSlavePage" or g_currentMission.guiMenue.pullDown.buttonType == "pullDownMods"))) then			
			optiSize = guiDraw:getOptimalSize(overlay["groundMaster"].width-horizontalTxtDistance, txt, g_currentMission.guiMenue.default.size-0.001);
			txtLength = getTextWidth(optiSize, txt);
			setTextColor(unpack(g_currentMission.guiMenue.default.textColor))
			renderText(posX+overlay["groundMaster"].width-horizontalTxtDistance-txtLength, posY+(verticalTxtDistance*2), optiSize, txt);
		end;
		--copyright Mod Version/Author
		-----------------------------------Master Gui Menue-----------------------------------
		
		-----------------------------------PullDown   Menue-----------------------------------
		function setPullDownMenue(pullDownTable, pullDownGround, maxLine, whereClick, whatClick)			
			if pullDownTable == nil or #pullDownTable <=0 then return;end;
			if #pullDownTable > 0 then
				--g_currentMission.guiMenue.pullDown.bounds[1] = pullDownGround.bounds1;
				--g_currentMission.guiMenue.pullDown.bounds[2] = pullDownGround.bounds2;
				g_currentMission.guiMenue.guiSetGet:setOverlay(self, g_currentMission.guiMenue.overlays["groundPullDown"], pullDownGround.x, pullDownGround.y, pullDownGround.width, pullDownGround.height);
				overlay["groundPullDown"]:render();
				local buttonType = {"slideUpModMasterPage", "slideDownModMasterPage", "slideLineUpDownModMasterPage"};	--master page slide buttons -buttonType=pullDownModMasterPage				
				for a=1, #pullDownTable do
					setTextColor(unpack(pullDownTable[a].color));
					setTextBold(pullDownTable[a].bold);
					renderText(pullDownTable[a].posX, pullDownTable[a].posY, pullDownTable[a].size, tostring(pullDownTable[a].txt));
					setTextBold(false);
					if not g_currentMission.guiMenue.dragDrop.on then
						guiDraw:setClickAreas(unpack(pullDownTable[a].clickArea));
					end;					
				end;
				if g_currentMission.guiMenue.pullDown.buttonType == "pullDownMods" then buttonType = {"slideUpMods", "slideDownMods", "slideLineUpDownMods"};end; --mods button
				if g_currentMission.guiMenue.pullDown.buttonType == "pullDownLineButton" then buttonType = {"slideUpLineButton", "slideDownLineButton", "slideLineUpDownLineButton"};end; --page side buttons
				if g_currentMission.guiMenue.pullDown.buttonType == "pullDownModSlavePage" then buttonType = {"slideUpModSlavePage", "slideDownModSlavePage", "slideLineUpDownModSlavePage"};end; --slave page slide buttons
				if maxLine > #pullDownTable then					
					g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["groundSlideButton"], g_currentMission.guiMenue.default.groundSlideButtonColor);
					g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundSlideButton"], overlay["groundPullDown"].x+overlay["groundPullDown"].width-horizontal, overlay["groundPullDown"].y+(vertical/2), horizontal, overlay["groundPullDown"].height-(vertical));
					overlay["groundSlideButton"]:render();					
					
					guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["groundSlideButton"], 0.0008, false, false, true, true, nil);
					guiDraw:setButtonType(self, overlay["buttonSlideUp"], {x=overlay["groundPullDown"].x, y=overlay["groundPullDown"].y+overlay["groundPullDown"].height-(vertical/2), width=overlay["groundPullDown"].width-horizontal});
					guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["buttonSlideUp"], 0.0008, true, false, true, true, nil);
					guiDraw:setClickAreas(overlay["buttonSlideUp"].x, overlay["buttonSlideUp"].x+overlay["buttonSlideUp"].width, overlay["buttonSlideUp"].y, overlay["buttonSlideUp"].y+overlay["buttonSlideUp"].height, tostring(buttonType[1]), tostring(whereClick), tostring(whatClick), "", nil, nil, nil, nil, nil, maxLine, masterPage, slavePage, pageSide, pageType);
										
					guiDraw:setButtonType(self, overlay["buttonSlideDown"], {x=overlay["groundPullDown"].x, y=overlay["groundPullDown"].y, width=overlay["groundPullDown"].width-horizontal});
					guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["buttonSlideDown"], 0.0008, false, true, true, true, nil);
					guiDraw:setClickAreas(overlay["buttonSlideDown"].x, overlay["buttonSlideDown"].x+overlay["buttonSlideDown"].width, overlay["buttonSlideDown"].y, overlay["buttonSlideDown"].y+overlay["buttonSlideDown"].height, tostring(buttonType[2]), tostring(whereClick), tostring(whatClick), "", nil, nil, nil, nil, nil, maxLine, masterPage, slavePage, pageSide, pageType);
					local slideOverlayTable = guiDraw:getSlideRegulatorOverlay(self, overlay["groundSlideButton"], #pullDownTable, maxLine, g_currentMission.guiMenue.pullDown.bounds[1], g_currentMission.guiMenue.pullDown.bounds[2], true, 0.0008);
					guiDraw:setSlideRegulatorOverlay(self, overlay["buttonSlideRegulator"], slideOverlayTable, nil);
					guiDraw:setClickAreas(overlay["groundPullDown"].x, overlay["groundPullDown"].x+overlay["groundPullDown"].width, overlay["groundPullDown"].y, overlay["groundPullDown"].y+overlay["groundPullDown"].height, tostring(buttonType[3]), tostring(whereClick), tostring(whatClick), "", nil, nil, nil, nil, nil, maxLine, masterPage, slavePage, pageSide, pageType);
				end;
			end;
		end;
		-----------------------------------PullDown   Menue-----------------------------------
		
		-----------------------------------Master Gui Menue-----------------------------------
		if not g_currentMission.guiMenue.dragDrop.on and g_currentMission.guiMenue.pullDown.open and (g_currentMission.guiMenue.pullDown.buttonType == "pullDownModMasterPage" or g_currentMission.guiMenue.pullDown.buttonType == "pullDownModSlavePage" or g_currentMission.guiMenue.pullDown.buttonType == "pullDownMods") then 
			local pullDownTable, pullDownGround, maxLine = guiDraw:getPullDownTable(nil, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
			setPullDownMenue(pullDownTable, pullDownGround, maxLine, "guiMasterMenue", "");		
		end;
		-----------------------------------Master Gui Menue-----------------------------------
		
		-----------------------------------Gui Menue ModPage----------------------------------viewPage = 2
		if g_currentMission.guiMenue.viewPage == 2 and modMenueActive and not modMenueHidden then		
			local linePosX = overlay["groundSlave"].x+(horizontal);
			local linePosY = overlay["groundSlave"].y+overlay["groundSlave"].height-(vertical*3)-verticalDistance;
			local lineWidth = overlay["groundSlave"].width-(horizontal*2);
			local lineHeight = overlay["groundSlave"].height;
			function setNextLine()
				linePosY = linePosY-(vertical*2)-verticalDistance-verticalTxtDistance;
			end;
			
			function getButtonWidth(maxButton)
				local buttonWidth = lineWidth;
				if maxButton > 1 then
					buttonWidth = (lineWidth-(horizontal*(maxButton-1)))/maxButton -- (horizontal) --*(maxButton-1));				
				end;
				return buttonWidth;
			end;			
			
			local maxPageLines = 1;			
			local guiModPageTable = guiModTable.page[masterPage];
			if pageType ~= nil and pageType == "modSlavePageSide" then 
				if guiModTable.page[masterPage] ~= nil and guiModTable.page[masterPage].page[slavePage] ~= nil then
					guiModPageTable = guiModTable.page[masterPage].page[slavePage];
				else
					pageType = nil;
				end;
			end;			
			if pageType ~= nil and guiModTable.page ~= nil and guiModTable.page[masterPage] ~= nil and guiModPageTable.side ~= nil and #guiModPageTable.side > 0 and guiModPageTable.side[pageSide] ~= nil and guiModPageTable.side[pageSide].viewLines ~= nil then				
				--page side info and to turn the side				
				if not g_currentMission.guiMenue.pullDown.open or (g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType == "pullDownLineButton") then
					local turnSideGroundWidth = overlay["groundSlave"].width/2;
					g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonBlank"], posX+(turnSideGroundWidth)-(turnSideGroundWidth/2), overlay["groundSlave"].y+(lineHeight)-vertical-verticalTxtDistance, turnSideGroundWidth, vertical+(verticalTxtDistance*2));
					if #guiModPageTable.side > 1 then
						infoText = "";
						local buttonTypeLeft = g_currentMission.guiMenue.default.buttonType[4];	
						guiDraw:setButtonType(self, overlay[buttonTypeLeft], {x=overlay["buttonBlank"].x-overlay["buttonBlank"].width-horizontal, y=overlay["buttonBlank"].y, width=overlay["buttonBlank"].width}, nil, true);
						local buttonTypeRight = g_currentMission.guiMenue.default.buttonType[5];
						guiDraw:setButtonType(self, overlay[buttonTypeRight], {x=overlay["buttonBlank"].x, y=overlay["buttonBlank"].y, width=overlay["buttonBlank"].width}, nil, true);
						if not disableClickAreas then
							guiDraw:setClickAreas(overlay["buttonLeft"].x, overlay["buttonLeft"].x+overlay["buttonLeft"].width, overlay["buttonLeft"].y, overlay["buttonLeft"].y+overlay["buttonLeft"].height, tostring("pageSideLeft"), "guiModPageMenue", "", tostring(infoText), nil, nil, nil, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
							guiDraw:setClickAreas(overlay["buttonRight"].x, overlay["buttonRight"].x+overlay["buttonRight"].width, overlay["buttonRight"].y, overlay["buttonRight"].y+overlay["buttonRight"].height, tostring("pageSideRight"), "guiModPageMenue", "", tostring(infoText), nil, nil, nil, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
						end;
					end;
					setTextBold(true);
					setTextColor(unpack(g_currentMission.guiMenue.default.textTurnSideColor));
					optiSize = g_currentMission.guiMenue.default.size+0.001;
					--side
					txt = "Side ".. tostring(pageSide).. "/".. tostring(#guiModPageTable.side);					
					renderText(overlay["groundSlave"].x+(horizontal), overlay["buttonBlank"].y+(verticalTxtDistance*2), optiSize, txt);
					--side
					txt = tostring(guiModPageTable.side[pageSide].name);									
					optiSize = g_currentMission.guiMenue.guiSetGet:optiHeightSize(self, overlay["buttonBlank"].height, txt, optiSize);
					--txtHeight = getTextHeight(optiSize, tostring(txt));
					txtLength = getTextWidth(optiSize, tostring(txt));				
					g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonBlank"], g_currentMission.guiMenue.default.groundTurnSideColor);				
					overlay["buttonBlank"]:render();
					guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["buttonBlank"], 0.0008, true, true, true, true, nil);
					renderText(overlay["buttonBlank"].x+(turnSideGroundWidth/2)-(txtLength/2), overlay["buttonBlank"].y+(verticalTxtDistance*3), optiSize, txt);
					setTextBold(false);
					g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["buttonBlank"], g_currentMission.guiMenue.default.buttonGroundColor);
					
					--Page Name
					--txt = tostring(guiModTable.name);
					--optiSize = g_currentMission.guiMenue.default.size;
					--optiSize = g_currentMission.guiMenue.guiSetGet:optiHeightSize(self, overlay["buttonBlank"].height, txt, optiSize);
					--txtLength = getTextWidth(optiSize, tostring(txt));
					--setTextColor(unpack(g_currentMission.guiMenue.default.textTitleModColor));
					--renderText(overlay["buttonBlank"].x+(horizontalTxtDistance), overlay["buttonBlank"].y+(verticalTxtDistance*3), optiSize, txt);
					--Page Name					
				end;
				--page side info and to turn the side
				
				local pullDownTable, pullDownGround, maxLine = {}, {}, {};			
				for a=guiModPageTable.side[pageSide].viewLines.bounds[1], #guiModPageTable.side[pageSide].line do
					if a <= guiModPageTable.side[pageSide].viewLines.bounds[2] then
						--local maxLine = guiDraw:getMaxSlaveLine(#guiModPageTable.side[pageSide].line, linePosY-(vertical)-verticalDistance)
						local line = guiModPageTable.side[pageSide].line[a];
						if line ~= nil then
							if line.maxButton > 0 and not line.isHidden then 
								--local buttonWidth = getButtonWidth(line.maxButton);	
								local buttonWidth, buttonPosX = guiDraw:getButtonWidthPosX_Table(line, linePosX, lineWidth, horizontal);	
								local lastButtonDistance = 0;
								for b=1, line.maxButton do					
									if line.button[b] ~= nil and not line.button[b].isHidden then
										local buttonTypeWidth = 0;
										if line.button[b].typ > 0 then buttonTypeWidth = horizontal;end;
										--g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonBlank"], linePosX+(buttonWidth*(b-1))+(horizontal*(b-1)), linePosY, buttonWidth-(buttonTypeWidth), vertical);
										
										if b > 1 then lastButtonDistance = 1;end;
										g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["buttonBlank"], buttonPosX[b]+(horizontal*lastButtonDistance), linePosY, buttonWidth[b]-(buttonTypeWidth)-(horizontal*lastButtonDistance), vertical);
										overlay["buttonBlank"]:render();
										if line.button[b].borderColor ~= nil and not g_currentMission.guiMenue.pullDown.open then
											guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["buttonBlank"], 0.001, true, true, true, true, line.button[b].borderColor);
										end;
										if line.button[b].typ > 0 then
											--g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundPushButton"], overlay["buttonBlank"].x+overlay["buttonBlank"].width, overlay["buttonBlank"].y, horizontal, vertical);
											--overlay["groundPushButton"]:render();
											local buttonType = g_currentMission.guiMenue.default.buttonType[line.button[b].typ]										
											local returnClickUp = g_currentMission.guiMenue.guiSetGet:getReturnClickString(buttonType, line.button[b].returnClick, true);
											local returnClickDown = g_currentMission.guiMenue.guiSetGet:getReturnClickString(buttonType, line.button[b].returnClick, false);										
											local txt, formatTable, color = guiDraw:formatCmdValues(line.button[b]);
											if formatTable ~= nil and #formatTable > 0 then
												pullDownTable[returnClickDown] = nil;
												pullDownGround[returnClickDown] = nil;
												maxLine[returnClickDown] = nil;
												pullDownTable[returnClickDown] = {};
												maxLine[returnClickDown] = {};
												pullDownGround[returnClickDown] = {};
												pullDownTable[returnClickDown], pullDownGround[returnClickDown], maxLine[returnClickDown] = guiDraw:getPullDownTable(formatTable, line.button[b].maxSelect, a, b, masterPage, slavePage, pageSide, pageType);
												--setPullDownMenue(pullDownTable, maxLine, false);										
											end;											
											setTextBold(true);
											guiDraw:renderTxt(nil, txt, {x=overlay["buttonBlank"].x,y=overlay["buttonBlank"].y,width=overlay["buttonBlank"].width+(buttonTypeWidth),height=overlay["buttonBlank"].height}, horizontal, horizontalTxtDistance, verticalTxtDistance, 0, nil, true, nil, line.button[b]);
											setTextBold(false);	
											
											if g_currentMission.guiMenue.pullDown.open and string.find(buttonType, "buttonOnOff") then buttonType = "buttonEmpty";color = nil;end; --disable color (as prio Overlay !!)
											guiDraw:setButtonType(self, overlay[buttonType], {x=overlay["buttonBlank"].x, y=overlay["buttonBlank"].y, width=overlay["buttonBlank"].width}, color, true)
											if not disableClickAreas and formatTable == nil then											
												if string.find(buttonType, "UpDown") then												
													guiDraw:setClickAreas(overlay[buttonType].x, overlay[buttonType].x+overlay[buttonType].width, overlay[buttonType].y+(overlay[buttonType].height/2), overlay[buttonType].y+overlay[buttonType].height, "clickLineButton", "guiModPageLineMenue", tostring(returnClickUp), tostring(line.button[b].infoTxt), nil, a, b, nil ,nil, nil, masterPage, slavePage, pageSide, pageType);
													guiDraw:setClickAreas(overlay[buttonType].x, overlay[buttonType].x+overlay[buttonType].width, overlay[buttonType].y, overlay[buttonType].y+(overlay[buttonType].height/2), "clickLineButton", "guiModPageLineMenue", tostring(returnClickDown), tostring(line.button[b].infoTxt), nil, a, b, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
												elseif string.find(buttonType, "LeftRight") then
													guiDraw:setClickAreas(overlay[buttonType].x, overlay[buttonType].x+(overlay[buttonType].width/2), overlay[buttonType].y, overlay[buttonType].y+overlay[buttonType].height, "clickLineButton", "guiModPageLineMenue", tostring(returnClickUp), tostring(line.button[b].infoTxt), nil, a, b, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
													guiDraw:setClickAreas(overlay[buttonType].x+(overlay[buttonType].width/2), overlay[buttonType].x+overlay[buttonType].width, overlay[buttonType].y, overlay[buttonType].y+overlay[buttonType].height, "clickLineButton", "guiModPageLineMenue", tostring(returnClickDown), tostring(line.button[b].infoTxt), nil, a, b, nil, nil, nil, masterPage, slavePage, pageSide, pageType)
												else
													guiDraw:setClickAreas(overlay[buttonType].x, overlay[buttonType].x+overlay[buttonType].width, overlay[buttonType].y, overlay[buttonType].y+overlay[buttonType].height, "clickLineButton", "guiModPageLineMenue", tostring(returnClickDown), tostring(line.button[b].infoTxt), nil, a, b, nil ,nil ,nil, masterPage, slavePage, pageSide, pageType);
												end;										
											end;
											if formatTable ~= nil then											
												guiDraw:setClickAreas(overlay[buttonType].x, overlay[buttonType].x+overlay[buttonType].width, overlay[buttonType].y, overlay[buttonType].y+overlay[buttonType].height, "pullDownLineButton", "guiModPageLineMenue", tostring(returnClickDown), tostring(line.button[b].infoTxt), {x=overlay["buttonBlank"].x,y=overlay["buttonBlank"].y,width=overlay["buttonBlank"].width,height=overlay["buttonBlank"].height}, a, b, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
											end;											
										end;							
										if line.button[b].txtOverButton ~= nil and string.len(line.button[b].txtOverButton) > 0 then
											local color = line.button[b].txtOverButtonColor;								
											if disableTxtColor then color = nil;end;
											setTextBold(true);
											guiDraw:renderTxt(color, tostring(line.button[b].txtOverButton), {x=overlay["buttonBlank"].x,y=overlay["buttonBlank"].y,width=overlay["buttonBlank"].width+(buttonTypeWidth),height=overlay["buttonBlank"].height}, horizontal, horizontalTxtDistance, verticalTxtDistance, 0, true, nil, nil, line.button[b]);
											setTextBold(false);
										end;
										if line.button[b].typ == 0 and line.button[b].buttonTxt ~= nil and string.len(line.button[b].buttonTxt) > 0 then
											local color = g_currentMission.guiMenue.default.infoTextColor;								
											if disableTxtColor then color = nil;end;
											setTextBold(true);
											guiDraw:renderTxt(color, tostring(line.button[b].buttonTxt), {x=overlay["buttonBlank"].x,y=overlay["buttonBlank"].y,width=overlay["buttonBlank"].width+(buttonTypeWidth),height=overlay["buttonBlank"].height}, horizontal, horizontalTxtDistance, verticalTxtDistance, 0, nil, true, nil, line.button[b]);
											setTextBold(false);
										end;										
										if line.button[b].helpIcon > 0 then
											guiDraw:setHelpIcon(self, line.button[b].helpIcon, overlay["buttonHelp"], overlay["buttonBlank"], overlay["buttonBlank"].width+(buttonTypeWidth), "guiModPageLineMenue", line, a, b, disableClickAreas, masterPage, slavePage, pageSide)
										elseif line.button[b].txtUnderButton ~= nil and string.len(line.button[b].txtUnderButton) > 0 then
											local color = line.button[b].txtUnderButtonColor;								
											if disableTxtColor then color = nil;end;
											setTextBold(true);
											guiDraw:renderTxt(color, tostring(line.button[b].txtUnderButton), {x=overlay["buttonBlank"].x,y=overlay["buttonBlank"].y,width=overlay["buttonBlank"].width+(buttonTypeWidth),height=overlay["buttonBlank"].height}, horizontal, horizontalTxtDistance, verticalTxtDistance*2, 0.001, nil, nil, true, line.button[b]);
											setTextBold(false);											
										end;									
									end;						
								end;
								setNextLine();
								maxPageLines = maxPageLines+1;
							else
								setNextLine();
								maxPageLines = maxPageLines+1;
							end;
						else
							setNextLine();
							maxPageLines = maxPageLines+1;
						end;
					else
						break;
					end;
				end;
				if not g_currentMission.guiMenue.dragDrop.on and g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType == "pullDownLineButton" then	
					local tempPullDownTable = pullDownTable[g_currentMission.guiMenue.pullDown.whatClick];
					local tempMaxLine = maxLine[g_currentMission.guiMenue.pullDown.whatClick];
					local tempPullDownGround = pullDownGround[g_currentMission.guiMenue.pullDown.whatClick];
					if tempPullDownTable ~= nil and tempMaxLine ~= nil and pullDownGround ~= nil then
						setPullDownMenue(tempPullDownTable, tempPullDownGround, tempMaxLine, "guiModPageLineMenue", g_currentMission.guiMenue.pullDown.whatClick);
					end;
				end;
				--pageSlide
				if guiModPageTable.side[pageSide].line ~= nil and #guiModPageTable.side[pageSide].line > maxPageLines-1 then
					infoText = "!! View Line ".. tostring(guiModPageTable.side[pageSide].viewLines.bounds[1]).. " - ".. tostring(guiModPageTable.side[pageSide].viewLines.bounds[2]).. " (".. tostring(#guiModPageTable.side[pageSide].line).. ") !!";
					local testHorizontal = horizontal/1.5; --ist 0 dann wird die hinter dem slave menue angezeigt, ist horizontal dann wird sie auf dem slave menue angezeigt
					g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundSlideButton"], overlay["groundSlave"].x+overlay["groundSlave"].width-testHorizontal, overlay["groundSlave"].y+(vertical/2), horizontal, overlay["groundSlave"].height-(vertical));
					g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay["groundSlideButton"], g_currentMission.guiMenue.default.groundSlideButtonColor);
					overlay["groundSlideButton"]:render();
					guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["groundSlideButton"], 0.0008, false, false, true, true, nil);
									
					guiDraw:setButtonType(self, overlay["buttonSlideUp"], {x=overlay["groundSlave"].x, y=overlay["groundSlave"].y+overlay["groundSlave"].height-(vertical/2), width=overlay["groundSlave"].width-testHorizontal}, nil, true);
					guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["buttonSlideUp"], 0.0008, true, false, true, true, nil);
					guiDraw:setClickAreas(overlay["buttonSlideUp"].x, overlay["buttonSlideUp"].x+overlay["buttonSlideUp"].width, overlay["buttonSlideUp"].y, overlay["buttonSlideUp"].y+overlay["buttonSlideUp"].height, tostring("pageLineUp"), "guiModPageMenue", "", tostring(infoText), nil, nil, nil, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
									
					guiDraw:setButtonType(self, overlay["buttonSlideDown"], {x=overlay["groundSlave"].x, y=overlay["groundSlave"].y, width=overlay["groundSlave"].width-testHorizontal}, nil, true);
					guiDraw:setButtonLineBorder(self, overlay["lineBorder"], overlay["buttonSlideDown"], 0.0008, false, true, true, true, nil);
					guiDraw:setClickAreas(overlay["buttonSlideDown"].x, overlay["buttonSlideDown"].x+overlay["buttonSlideDown"].width, overlay["buttonSlideDown"].y, overlay["buttonSlideDown"].y+overlay["buttonSlideDown"].height, tostring("pageLineDown"), "guiModPageMenue", "", tostring(infoText), nil ,nil, nil, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
					infoText = "";
					local slideOverlayTable = guiDraw:getSlideRegulatorOverlay(self, overlay["groundSlideButton"], maxPageLines-1, #guiModPageTable.side[pageSide].line, guiModPageTable.side[pageSide].viewLines.bounds[1], guiModPageTable.side[pageSide].viewLines.bounds[2], true, 0.0008);
					guiDraw:setSlideRegulatorOverlay(self, overlay["buttonSlideRegulator"], slideOverlayTable, nil);
					guiDraw:setClickAreas(overlay["groundSlave"].x, overlay["groundSlave"].x+overlay["groundSlave"].width+(horizontal/2), overlay["groundSlave"].y, overlay["groundSlave"].y+overlay["groundSlave"].height, tostring("pageLineSlideUpDown"), "guiModPageMenue", "", tostring(infoText), nil, nil, nil, nil, nil, nil, masterPage, slavePage, pageSide, pageType);
				elseif guiModPageTable.side[pageSide].line ~= nil then --?? for optics set blind slideRegulator ?? just take a look, later
					
				end;		
				--pageSlide
				--helpText
				if g_currentMission.guiMenue.helpText.txt ~= nil and string.len(g_currentMission.guiMenue.helpText.txt) > 0 then
					txt = tostring(g_currentMission.guiMenue.helpText.txt);				
					txtLength = getTextWidth(g_currentMission.guiMenue.default.size, asciiToUtf8(tostring(txt)));
					txtHeight = getTextHeight(g_currentMission.guiMenue.default.size, tostring(txt));				
					g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay["groundHelpTxt"], g_currentMission.guiMenue.helpText.posX+(horizontal)-(horizontalTxtDistance), g_currentMission.guiMenue.helpText.posY-(txtHeight-verticalDistance), txtLength+(horizontal*2), txtHeight+(verticalTxtDistance*4));
					overlay["groundHelpTxt"]:render();				
					setTextColor(unpack(g_currentMission.guiMenue.default.helpTextColor));
					setTextBold(true);
					renderText(g_currentMission.guiMenue.helpText.posX+horizontal, g_currentMission.guiMenue.helpText.posY, g_currentMission.guiMenue.default.size, txt);
					setTextBold(false);				
				end;
				--helpText
			end;
		end;
		-----------------------------------Gui Menue ModPage----------------------------------viewPage = 2
		
		-------------------------------Show Info Box Text Gui Menue------------------------------
		if g_currentMission.guiMenue.viewPage == 1 or g_currentMission.guiMenue.viewPage == 2 then			
			--info txt
			if g_currentMission.guiMenue.infoText.txt ~= nil and string.len(g_currentMission.guiMenue.infoText.txt) > 0 or string.len(g_currentMission.guiMenue.dragDrop.warning) > 0 then
				if g_currentMission.guiMenue.dragDrop.color ~= nil then --is DragDrop Warning
					setTextColor(unpack(g_currentMission.guiMenue.dragDrop.color));
					txtHeight = getTextHeight(0.013, tostring("Gg"));
					txt = tostring(g_currentMission.guiMenue.dragDrop.warning);
					renderText(posX+(horizontalTxtDistance*2), overlay["groundInfoBox"].y+overlay["groundInfoBox"].height-(txtHeight), 0.013, txt);
					return;
				else
					setTextColor(unpack(g_currentMission.guiMenue.default.infoTextColor));
					txt = tostring(g_currentMission.guiMenue.infoText.txt);
				end;				
				optiSize = g_currentMission.guiMenue.default.size+0.001; --guiDraw:getOptimalSize(g_currentMission.guiMenue.default.width-(horizontalTxtDistance*2), txt, g_currentMission.guiMenue.default.size);
				optiSize = g_currentMission.guiMenue.guiSetGet:optiHeightSize(self, overlay["groundInfoBox"].height, txt, optiSize)
				txtHeight = getTextHeight(optiSize, tostring("Gg"));			
				local beginLine, endLine = g_currentMission.guiMenue.guiSetGet:txtLineBounds(self, txt, optiSize, overlay["groundInfoBox"].width-(horizontalTxtDistance*2), 400);
				setTextWrapWidth(overlay["groundInfoBox"].width-(horizontalTxtDistance*2));			
				setTextLineBounds(beginLine, endLine);
				renderText(posX+horizontalTxtDistance, overlay["groundInfoBox"].y+overlay["groundInfoBox"].height-txtHeight, optiSize, txt);
				setTextWrapWidth(0);
				setTextLineBounds(0, 0);
			end;
			--info txt
		end;		
		-------------------------------Show Info Box Text Gui Menue------------------------------
	end;
	setTextAlignment(0);
	setTextLineBounds(0, 0);
	setTextWrapWidth(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false)
end;

function guiDraw:formatCmdValues(buttonLineTable, underTable)
	local cmdType = buttonLineTable.cmdType;
	local txt = ""
	local color = nil;
	local formatPullDownTable = nil;
	local buttonType = g_currentMission.guiMenue.default.buttonType[buttonLineTable.typ]
	if string.find(cmdType, "stringOnly") then
		txt = tostring(buttonLineTable.buttonTxt);
	elseif buttonLineTable.cmdTable == nil then
		txt = tostring(g_currentMission.guiMenue.default.errorCmdTxt);
	elseif string.find(cmdType, "string") then
		local getCmd = buttonLineTable.cmdTable[buttonLineTable.cmdValue];
		txt = tostring(getCmd);
		if buttonLineTable.buttonTxtAndCmd then txt = buttonLineTable.buttonTxt.. " ".. txt;end;
	elseif string.find(cmdType, "int") and tonumber(buttonLineTable.cmdTable[buttonLineTable.cmdValue]) then
		local getCmd = buttonLineTable.cmdTable[buttonLineTable.cmdValue];
		txt = tostring(getCmd);
		if buttonLineTable.buttonTxtAndCmd then txt = buttonLineTable.buttonTxt.. " ".. txt;end;
	elseif string.find(cmdType, "float") and tonumber(buttonLineTable.cmdTable[buttonLineTable.cmdValue]) then
		local getCmd = buttonLineTable.cmdTable[buttonLineTable.cmdValue];
		txt = string.format("%".. tostring(buttonLineTable.buttonTxt).. "f", "".. tonumber(getCmd));
		if buttonLineTable.buttonTxtAndCmd then txt = buttonLineTable.buttonTxt.. " ".. txt;end;
	elseif string.find(cmdType, "boolean") then
		local getCmd = buttonLineTable.cmdTable[buttonLineTable.cmdValue];																				
		if getCmd then txt = "ON";color=g_currentMission.guiMenue.guiSetGet.colors["green"];else txt="OFF";color=g_currentMission.guiMenue.guiSetGet.colors["red"];end;		
		if not underTable then
			if not string.find(buttonType, "OnOff") then color=nil;end;
			if string.len(buttonLineTable.buttonTxt) > 0 then txt = tostring(buttonLineTable.buttonTxt);end;
		end;		
		if buttonLineTable.buttonTxtAndCmd then txt = buttonLineTable.buttonTxt.. " ".. txt;end;				
	elseif string.find(cmdType, "money") then
		local getCmd = buttonLineTable.cmdTable[buttonLineTable.cmdValue];
		txt = g_i18n:formatMoney(Utils.getNoNil(getCmd, 0));
		if buttonLineTable.buttonTxtAndCmd then txt = buttonLineTable.buttonTxt.. " ".. txt;end;
	elseif string.find(cmdType, "pullDown") and underTable == nil then
		local firstTxt = false;
		txt = tostring(buttonLineTable.buttonTxt);
		for a=1, #buttonLineTable.cmdTable do
			local tempTxt, _ = guiDraw:formatCmdValues(buttonLineTable.cmdTable[a], true);			 
			if formatPullDownTable == nil then formatPullDownTable = {};end;
			--if buttonLineTable.cmdTable[a].buttonTxtAndCmd then tempTxt = buttonLineTable.cmdTable[a].buttonTxt.. " ".. tempTxt;end;
			formatPullDownTable[#formatPullDownTable+1] = {};
			formatPullDownTable[#formatPullDownTable].name = tostring(tempTxt);
			formatPullDownTable[#formatPullDownTable].isSelect = buttonLineTable.cmdTable[a].isSelect;
			formatPullDownTable[#formatPullDownTable].infoTxt = buttonLineTable.cmdTable[a].infoTxt or "";
			if buttonLineTable.cmdTable[a].isSelect and not firstTxt then txt = tostring(tempTxt);firstTxt=true;end;
		end;
		local txtTemp = tostring(buttonLineTable.buttonTxt); --multiple Select set buttonTxt is found this
		if string.len(txtTemp) > 0 then txt = txtTemp;end; 
		--local pullDownTable, maxLine = guiDraw:getPullDownTable(buttonLineTable.cmdTable, buttonLineTable.maxSelect);
		--setPullDownMenue(pullDownTable, maxLine, false);
	end;		
	return txt, formatPullDownTable, color;
end;

function guiDraw:getMaxTextWidthHeight(txtString, size)
	local txtWidth = (g_currentMission.guiMenue.default.buttonGfxWidth1*2)*getTextWidth(size, tostring("G"));	
	local txtLength = string.len(txtString);	
	local txtHeight = getTextHeight(size, tostring("Gg"));
	if string.find(txtString, "\n") then
		local stringSplit = Utils.splitString("\n", txtString);
		if stringSplit ~= nil and #stringSplit > 0 then
			for a=1, #stringSplit do
				if string.len(stringSplit[a]) > txtLength then
					txtLength = string.len(stringSplit[a]);
				end;				
			end;
			txtHeight = txtHeight*#stringSplit;
		end;
	end;
	return txtWidth*txtLength, txtHeight;
end;

function guiDraw:getPullDownTable(modPageLineButton, maxSelect, line, button, masterPage, slavePage, pageSide, pageType)
	local clickArea = g_currentMission.guiMenue.pullDown.clickArea;	
	local height = 0;
	local seeNotAllLine = false;
	local pullDownTable = {};
	local pullDownGround = {};
	local pullDown = {};
	local groundOverlay = "";
	local whereClick = "";	
	local modTable = g_currentMission.guiMenue.mod;
	local guiModTable = g_currentMission.guiMenue.modTable[modTable];
	if clickArea ~= 0 then
		local overlay = g_currentMission.guiMenue.pullDown.clickArea.referenceButton;
		if overlay ~= nil then			
			local width = g_currentMission.guiMenue.overlays["buttonDragDrop"].width;
			local vertical = g_currentMission.guiMenue.overlays["buttonDragDrop"].height;			
			local pullDownMenueIsDown = true;
			local pullDownOpen = "";
			if g_currentMission.guiMenue.pullDown.buttonType == "pullDownMods" then
				groundOverlay = "groundMaster";
				pullDown = g_currentMission.guiMenue.modTable;
				pullDownOpen = "pullDownOpenMods";
				whereClick = "guiMasterMenue";
				whatClick = "";
				pullDownMenueIsDown = true; 
			elseif g_currentMission.guiMenue.pullDown.buttonType == "pullDownModMasterPage" then
				groundOverlay = "groundMaster";
				pullDown = guiModTable.page;
				pullDownOpen = "pullDownOpenModMasterPage";
				whereClick = "guiMasterMenue";
				whatClick = "";
				pullDownMenueIsDown = true; 
			elseif g_currentMission.guiMenue.pullDown.buttonType == "pullDownModSlavePage" then
				groundOverlay = "groundMaster";
				pullDown = guiModTable.page[masterPage].page;
				pullDownOpen = "pullDownOpenModSlavePage";
				whereClick = "guiMasterMenue";
				whatClick = "";
				pullDownMenueIsDown = true;	
			elseif modPageLineButton ~= nil then --and g_currentMission.guiMenue.pullDown.buttonType == "pullDownPageLine" then
				groundOverlay = "groundSlave";
				whereClick = "guiModPageLineMenue";				
				local tempLineButton = nil;
				if pageType == "modSlavePageSide" then 
					tempLineButton = guiModTable.page[masterPage].page[slavePage].side[pageSide].line[line].button[button];
				else 
					tempLineButton = guiModTable.page[masterPage].side[pageSide].line[line].button[button];
				end;
				local buttonType = g_currentMission.guiMenue.default.buttonType[tempLineButton.typ];				
				whatClick = tostring(g_currentMission.guiMenue.guiSetGet:getReturnClickString(buttonType, tempLineButton.returnClick, false));
				pullDownOpen = "pullDownOpenLineButtonModPage";				
				pullDownMenueIsDown = true; --guiDraw:getPullDownMenueNearDown(self, overlay, g_currentMission.guiMenue.overlays["groundSlave"]) --deaktiviert, priority text and overlay !! why !! :-( Giants
				pullDown = modPageLineButton;				
			end;
			local b=0;			
			for a=1, #pullDown do				
				if a >= g_currentMission.guiMenue.pullDown.bounds[1] then
					local txt = pullDown[a].name;
					local optiSize = guiDraw:getOptimalSize(overlay.width-g_currentMission.guiMenue.default.horizontalTxtDistance, tostring(txt), g_currentMission.guiMenue.default.size);
					local txtHeight = getTextHeight(optiSize, tostring(txt));
					height = height + txtHeight + g_currentMission.guiMenue.default.verticalTxtDistance;					
					g_currentMission.guiMenue.pullDown.toType = "down";
					if not pullDownMenueIsDown then g_currentMission.guiMenue.pullDown.toType = "up";end;
					
					local endPullDownHeight = overlay.y-height-(g_currentMission.guiMenue.default.verticalTxtDistance) >= g_currentMission.guiMenue.overlays[groundOverlay].y-(g_currentMission.guiMenue.default.verticalTxtDistance);
					--master gui menue pulldown virtuell erweitern nach unten
					if groundOverlay == "groundMaster" then
						endPullDownHeight = overlay.y-height-g_currentMission.guiMenue.default.verticalTxtDistance >= g_currentMission.guiMenue.overlays[groundOverlay].y-(vertical*2.5); ---last vertical higher bigger
					end;
					--master gui menue pulldown virtuell erweitern nach unten
					
					if not pullDownMenueIsDown then endPullDownHeight = overlay.y+height+g_currentMission.guiMenue.default.verticalTxtDistance <= g_currentMission.guiMenue.overlays[groundOverlay].y+g_currentMission.guiMenue.overlays[groundOverlay].height-(vertical*2);end;
					if endPullDownHeight then						
						b=b+1;
						pullDownTable[b] = {};
						pullDownTable[b].txt = pullDown[a].name;
						pullDownTable[b].infoTxt = pullDown[a].infoTxt or "";
						pullDownTable[b].size = optiSize;
						if modPageLineButton ~= nil and maxSelect > 1 and pullDown[a].isSelect then
							pullDownTable[b].color = g_currentMission.guiMenue.default.pullDownTextSelectActiveColor
						else
							if pullDownOpen == "pullDownOpenMods" and (not pullDown[a].isGenerate or pullDown[a].isHidden) then
								pullDownTable[b].color = g_currentMission.guiMenue.default.pullDownTextNotActiveColor
							else
								pullDownTable[b].color = g_currentMission.guiMenue.default.pullDownTextColor;
							end;
						end;
						if modPageLineButton == nil then line = a;end;
						pullDownTable[b].posX = overlay.x+g_currentMission.guiMenue.default.horizontalTxtDistance						
						if not pullDownMenueIsDown then 
							pullDownTable[b].posY = overlay.y+(vertical/2)+(height);
							pullDownTable[b].clickArea = {overlay.x, overlay.x+overlay.width, pullDownTable[b].posY, pullDownTable[b].posY+txtHeight, tostring(pullDownOpen), tostring(whereClick), tostring(whatClick), tostring(pullDown[a].infoTxt or ""), {x=overlay.x,y=overlay.y,width=overlay.width,height=txtHeight+g_currentMission.guiMenue.default.verticalTxtDistance}, line, button, a, nil, nil, masterPage, slavePage, pageSide};
						
						else
							pullDownTable[b].posY = overlay.y-(height);
							pullDownTable[b].clickArea = {overlay.x, overlay.x+overlay.width, overlay.y-(height), overlay.y-(height)+txtHeight, tostring(pullDownOpen), tostring(whereClick), tostring(whatClick), tostring(pullDown[a].infoTxt or ""), {x=overlay.x,y=overlay.y,width=overlay.width,height=txtHeight+g_currentMission.guiMenue.default.verticalTxtDistance}, line, button, a, nil, nil, masterPage, slavePage, pageSide};
						end;
						pullDownTable[b].bold = g_currentMission.guiMenue.pullDown.line == a;						
					else						
						height = height - txtHeight - g_currentMission.guiMenue.default.verticalTxtDistance;
						if not pullDownMenueIsDown then 
							--height = height + txtHeight + g_currentMission.guiMenue.default.verticalTxtDistance;						
						end;
						seeNotAllLine = true;
						--g_currentMission.guiMenue.pullDown.maxLine = b;
						if g_currentMission.guiMenue.pullDown.bounds[2] <= 1 then g_currentMission.guiMenue.pullDown.bounds[2] = b;end;						
						break;						
					end;					
				end;
			end;			
			if not pullDownMenueIsDown then				
				--g_currentMission.guiMenue.guiSetGet:setOverlay(self, g_currentMission.guiMenue.overlays["groundPullDown"], overlay.x, overlay.y+vertical+g_currentMission.guiMenue.default.verticalTxtDistance, overlay.width+width, height+g_currentMission.guiMenue.default.verticalTxtDistance);
				pullDownGround.bounds1 = g_currentMission.guiMenue.pullDown.bounds[1]; pullDownGround.bounds2 = b; pullDownGround.x = overlay.x; pullDownGround.y = overlay.y+(vertical)+g_currentMission.guiMenue.default.verticalTxtDistance; pullDownGround.width = overlay.width+width; pullDownGround.height = height+g_currentMission.guiMenue.default.verticalTxtDistance;
			else									
				--g_currentMission.guiMenue.guiSetGet:setOverlay(self, g_currentMission.guiMenue.overlays["groundPullDown"], overlay.x, overlay.y-height-g_currentMission.guiMenue.default.verticalTxtDistance, overlay.width+width, height+g_currentMission.guiMenue.default.verticalTxtDistance);
				pullDownGround.bounds1 = g_currentMission.guiMenue.pullDown.bounds[1]; pullDownGround.bounds2 = g_currentMission.guiMenue.pullDown.bounds[2]; pullDownGround.x = overlay.x; pullDownGround.y = overlay.y-height-g_currentMission.guiMenue.default.verticalTxtDistance; pullDownGround.width = overlay.width+width; pullDownGround.height = height+g_currentMission.guiMenue.default.verticalTxtDistance;
			end;
		end;				
	end;	
	return pullDownTable, pullDownGround, #pullDown;
end;

function guiDraw:getPullDownMenueNearDown(self, button, referenceButton)
	local lastUpPosY = referenceButton.y+referenceButton.height-button.height;
	local lastDownPosY = referenceButton.y+button.height/2;
	local upNear = button.y+button.height < lastUpPosY/2
	local middlePos = referenceButton.y+(referenceButton.height/2)
	local downBetter = button.y > middlePos	
	return button.y > middlePos;
	--return button.y - referenceButton.y >= (referenceButton.y+referenceButton.height) - button.y;
end;

function guiDraw:getSlideRegulatorOverlay(self, referenceButton, viewLines, maxLines, bounds_1, bounds_2, upDown, lineFat)
	local slideTable = {};
	local widthOrHeight = 0;
	local oneLines = 0;
	local lineFat = lineFat or 0;
	if upDown then
		widthOrHeight = referenceButton.height/maxLines;		
		if widthOrHeight < g_currentMission.guiMenue.default.minSlideRegulator then
			--widthOrHeight = g_currentMission.guiMenue.default.minSlideRegulator;			
		end;
		oneLines = widthOrHeight;
		widthOrHeight = oneLines*viewLines;
	else
		---leftRight slide
	end;
	if widthOrHeight and oneLines > 0 and upDown then
		slideTable.width = referenceButton.width-(lineFat*2);
		slideTable.height = widthOrHeight;
		slideTable.x = referenceButton.x+(lineFat);
		local tempPosY = 0;
		if bounds_1 == 1 then slideTable.y = referenceButton.y+referenceButton.height-widthOrHeight;
		elseif bounds_2 == maxLines then slideTable.y = referenceButton.y;
		else			
			local posLine2 = maxLines-bounds_2;
			local posLine1 = maxLines-posLine2-viewLines;
			slideTable.y = referenceButton.y+(oneLines*posLine2);			
		end;
	end;
	return slideTable;
end;

function guiDraw:setSlideRegulatorOverlay(self, overlay, slideOverlayTable, color, clickAreaTable)
	if color ~= nil then g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay, color);else g_currentMission.guiMenue.guiSetGet:setBackgroundColor(overlay, g_currentMission.guiMenue.default.groundSlideRegulatorColor);end;
	g_currentMission.guiMenue.guiSetGet:setOverlay(self, overlay, slideOverlayTable.x, slideOverlayTable.y, slideOverlayTable.width, slideOverlayTable.height);
	overlay:render();
end;

function guiDraw:setHelpIcon(self, maxHelpIcon, helpOverlay, referenceButton, maxWidth, whereClick, lineTable, line, button, disableClickAreas, masterPage, slavePage, pageSide)
	local posX = referenceButton.x+g_currentMission.guiMenue.default.horizontalTxtDistance;
	for a=1, maxHelpIcon do
		if posX < referenceButton.x+maxWidth then
			if a == 1 then
				g_currentMission.guiMenue.guiSetGet:setOverlay(self, helpOverlay, posX, referenceButton.y-helpOverlay.height-g_currentMission.guiMenue.default.verticalTxtDistance);
				posX = posX+helpOverlay.width+g_currentMission.guiMenue.default.horizontalTxtDistance;
			else
				g_currentMission.guiMenue.guiSetGet:setOverlay(self, helpOverlay, posX, referenceButton.y-helpOverlay.height-g_currentMission.guiMenue.default.verticalTxtDistance);
				posX = posX+helpOverlay.width+g_currentMission.guiMenue.default.horizontalTxtDistance;
			end;
			g_currentMission.guiMenue.guiSetGet:setBackgroundColor(helpOverlay, g_currentMission.guiMenue.default.infoTextColor);
			helpOverlay:render();
			if not disableClickAreas then
				guiDraw:setClickAreas(helpOverlay.x, helpOverlay.x+helpOverlay.width, helpOverlay.y, helpOverlay.y+helpOverlay.height, "clickHelpIcon", tostring(whereClick), "", "", nil, nil, button, nil, tostring(lineTable.button[button].helpTxt[a]), nil, masterPage, slavePage, pageSide);
			end;
		end;
	end;		
	
end;

function guiDraw:renderTxt(txtColor, txtString, referenceButton, horizontal, horizontalTxtDistance, verticalTxtDistance, differencSize, overButton, inTheButton, underButton, buttonTable)
	if txtColor == nil then setTextColor(unpack(g_currentMission.guiMenue.default.textColor));else setTextColor(unpack(txtColor));end;	
	local txt = tostring(txtString);
	local optiSize = guiDraw:getOptimalSize(referenceButton.width-(horizontal)-horizontalTxtDistance, txt, g_currentMission.guiMenue.default.size);			
	local txtHeight = 0;
	if underButton or inTheButton then txtHeight = getTextHeight(optiSize, tostring(txt));end;
	if overButton then
		renderText(referenceButton.x+horizontalTxtDistance, referenceButton.y+referenceButton.height+verticalTxtDistance, optiSize-differencSize, tostring(txt));
	elseif underButton then
		renderText(referenceButton.x+horizontalTxtDistance, referenceButton.y+(verticalTxtDistance)-txtHeight, optiSize-differencSize, tostring(txt));
	elseif inTheButton then			
		if buttonTable ~= nil and buttonTable.moveButtonTxt ~= nil and buttonTable.moveButtonTxt and buttonTable.moveTxt ~= nil then			
			local moveTxtOptiSize = guiSetGet:optiHeightSize(self, referenceButton.height, "W", g_currentMission.guiMenue.default.size-differencSize)
			txtHeight = getTextHeight(optiSize, tostring(txt));
			local moveTxt = guiDraw:setRenderMoveTxt(txt, optiSize-differencSize, referenceButton, horizontal, horizontalTxtDistance, moveTxtOptiSize, buttonTable)
			renderText(buttonTable.moveTxt.posX, referenceButton.y+(verticalTxtDistance*2), moveTxtOptiSize, tostring(moveTxt));
		else		
			renderText(referenceButton.x+horizontalTxtDistance, referenceButton.y+(verticalTxtDistance*2), optiSize-differencSize, tostring(txt));
			--renderText(referenceButton.x+horizontalTxtDistance, referenceButton.y+(referenceButton.height/2)-(txtHeight/2)+verticalTxtDistance, optiSize-differencSize, tostring(txt));
		end;
	end;	
end;

function guiDraw:setRenderMoveTxt(txt, optiSize, referenceButton, horizontal, horizontalTxtDistance, optiSize, buttonTable)	--later new is not 100%, ! only for buttonType 0 !
	local txtWidthLetter = getTextWidth(optiSize, "W");
	local firstPosX = referenceButton.x+referenceButton.width-horizontalTxtDistance-(horizontal*2);
	local endPosX = referenceButton.x+(horizontalTxtDistance*2);
	local width = referenceButton.width-(horizontal)-(horizontalTxtDistance*3);	
	if buttonTable.moveTxt.posX == 0 or buttonTable.moveTxt.lastMaxWidth ~= width or buttonTable.moveTxt.lastFirstPosX ~= firstPosX or buttonTable.moveTxt.lastEndPosX ~= endPosX then buttonTable.moveTxt.bounds[1]=0;buttonTable.moveTxt.bounds[2]=0;buttonTable.moveTxt.posX = firstPosX;buttonTable.moveTxt.lastFirstPosX=firstPosX;buttonTable.moveTxt.lastEndPosX=endPosX;buttonTable.moveTxt.lastMaxWidth=width;end;
	local txtLength = string.len(tostring(txt));
	local txtWidth = getTextWidth(optiSize, tostring(txt));
	local bounds1 = buttonTable.moveTxt.bounds[1];
	local bounds2 = buttonTable.moveTxt.bounds[2];	
	local moveTxt = string.sub(txt , bounds1, bounds2);	
	if not g_currentMission.guiMenue.guiSetGet:runsTimer("2mSec") then
		local bounds2Stop = true;		
		if bounds2+1 <= txtLength then 
			bounds2 = bounds2+1;
			buttonTable.moveTxt.bounds[2] = bounds2;
			local txtWidth = getTextWidth(optiSize, tostring(moveTxt));	
			if txtWidth <= width and buttonTable.moveTxt.posX >= endPosX then
				buttonTable.moveTxt.posX = firstPosX-txtWidth;
			elseif bounds1+1 <= txtLength then
				bounds1 = bounds1+1;
				buttonTable.moveTxt.bounds[1] = bounds1;			
			end;
			bounds2Stop = false;
		end;	
		if bounds2Stop and bounds1+1 <= txtLength then
			bounds1 = bounds1+1;
			buttonTable.moveTxt.bounds[1] = bounds1;			
		end;		
		if bounds1 == bounds2 then
			buttonTable.moveTxt.waitMove = buttonTable.moveTxt.waitMove+1;
			if buttonTable.moveTxt.waitMove >= 2 then 
				buttonTable.moveTxt.waitMove = 0;buttonTable.moveTxt.bounds[1]=0;buttonTable.moveTxt.bounds[2]=0;buttonTable.moveTxt.posX=0;buttonTable.moveTxt.lastFirstPosX=0;buttonTable.moveTxt.lastEndPosX=0;buttonTable.moveTxt.lastMaxWidth=0; --reset
			end;
		end;				
	end;	
	return moveTxt;
end;

function guiDraw:foundModNotSave(self)
	local value = 0;
	local modName = "";
	for a=1, #g_currentMission.guiMenue.modTable do
		if g_currentMission.guiMenue.modTable[a].tempSave then 
			value = value+1;
			if string.len(modName) <= 0 then
				modName = tostring(g_currentMission.guiMenue.modTable[a].name);
			else
				modName = modName.. ",".. tostring(g_currentMission.guiMenue.modTable[a].name);
			end;
		end;
	end;
	return value, modName;
end;

function guiDraw:getButtonWidthPosX_Table(line, linePosX, lineWidth, horizontal)
			
	function getButtonPosX(buttonWidth, linePosX)
		local posX = linePosX;
		local buttonPosX = {};
		for a=1, #buttonWidth do
			if a == 1 then
				buttonPosX[#buttonPosX+1] = posX;
			else
				posX = posX+buttonWidth[a-1];
				buttonPosX[#buttonPosX+1] = posX; --+horizontal;
			end;
		end;
		return buttonPosX;
	end;
	
	local buttonWidthDefault = lineWidth/line.maxButton; --(lineWidth-(horizontal*(line.maxButton-1)))/line.maxButton;
	local buttonWidth = {};	
	local buttonWidthTemp = {};	
	local foundButtonWidth = false;
	local minus = false;
	for a=1, line.maxButton do
		if line.button[a] ~= nil then
			if line.button[a].width == nil or line.button[a].width == 0 then					
				buttonWidth[#buttonWidth+1] = buttonWidthDefault;					
			else
				if line.button[a].width < 0 then minus = true;end;
				if not minus then 
					buttonWidth[#buttonWidth+1] = buttonWidthDefault+(horizontal*line.button[a].width);						 
				else						
					buttonWidth[#buttonWidth+1] = buttonWidthDefault-(horizontal*math.abs(line.button[a].width));
				end;					
				foundButtonWidth = true;					
			end;
		end;
	end;
	if not foundButtonWidth then				
		return buttonWidth, getButtonPosX(buttonWidth, linePosX);
	else
		
	
		local buttonsWidth = 0;		
		for a=1, #buttonWidth do
			buttonsWidth = buttonsWidth+buttonWidth[a];
		end;
		if line.buttonAutoWidth and buttonsWidth < lineWidth then
			local i = 0;
			while buttonsWidth < lineWidth do
				i = i + (horizontal/2)/2/2/2;
				buttonsWidth = 0;
				buttonWidthTemp = {};
				for a=1, #buttonWidth do
					buttonsWidth = buttonsWidth+(buttonWidth[a]+i);
					buttonWidthTemp[#buttonWidthTemp+1] = buttonWidth[a]+i;
				end;
			end;
			buttonWidth = buttonWidthTemp;
		end;
		local buttonsWidth = 0;		
		for a=1, #buttonWidth do
			buttonsWidth = buttonsWidth+buttonWidth[a];
		end;
		if buttonsWidth > lineWidth then			
			local i = 0;
			while buttonsWidth > lineWidth do
				i = i + (horizontal/2)/2/2/2;
				buttonsWidth = 0;
				buttonWidthTemp = {};
				for a=1, #buttonWidth do
					if buttonWidth[a]-i < horizontal then 
						buttonsWidth = buttonsWidth+(buttonWidth[a]);
						buttonWidthTemp[#buttonWidthTemp+1] = buttonWidth[a];
					else
						buttonsWidth = buttonsWidth+(buttonWidth[a]-i);
						buttonWidthTemp[#buttonWidthTemp+1] = buttonWidth[a]-i;
					end;
				end;
			end;
			buttonWidth = buttonWidthTemp;		
		end;
	end;			
	return buttonWidth, getButtonPosX(buttonWidth, linePosX);
end;

function guiDraw:getOptimalSize(width, txtString, defaultSize)
	local length = getTextWidth(defaultSize, tostring(txtString));
	local default = defaultSize;
	if length > width then
		local i = 0;
		while length > width do
			i = i + 0.0005;
			length = getTextWidth(defaultSize-i, tostring(txtString));
		end
		return defaultSize-i;
	end;
	return default;
end;

function guiDraw:setButtonLineBorder(self, line, button, fat, up, down, left, right, color)	
	if color ~= nil then g_currentMission.guiMenue.guiSetGet:setBackgroundColor(line, color);else g_currentMission.guiMenue.guiSetGet:setBackgroundColor(line, g_currentMission.guiMenue.default.lineBorderModColor);end;
	g_currentMission.guiMenue.guiSetGet:setOverlay(self, line, button.x+fat, button.y+(button.height)-fat, button.width-(fat*2), fat);	
	if up then line:render();end;
	g_currentMission.guiMenue.guiSetGet:setOverlay(self, line, button.x+fat, button.y, button.width-(fat*2), fat);
	if down then line:render();end;
	
	g_currentMission.guiMenue.guiSetGet:setOverlay(self, line, button.x, button.y, fat, button.height);
	if left then line:render();end;
	g_currentMission.guiMenue.guiSetGet:setOverlay(self, line, button.x+(button.width)-(fat*1), button.y, fat, button.height);
	if right then line:render();end;
end;

function guiDraw:setButtonType(self, buttonType, referenceButton, color, groundPushButton, groundPushButtonColor, newWidth, newHeight)	
	if color ~= nil then g_currentMission.guiMenue.guiSetGet:setBackgroundColor(buttonType, color);else g_currentMission.guiMenue.guiSetGet:setBackgroundColor(buttonType, g_currentMission.guiMenue.default.buttonTypeColor);end;
	local posX = referenceButton.x+referenceButton.width;
	local newHeight = newHeight or nil;
	local newWidth = newWidth or nil;	
	g_currentMission.guiMenue.guiSetGet:setOverlay(self, buttonType, posX, referenceButton.y, newWidth, newHeight);
	if groundPushButton ~= nil and groundPushButton then
		if groundPushButtonColor ~= nil then g_currentMission.guiMenue.guiSetGet:setBackgroundColor(g_currentMission.guiMenue.overlays["groundPushButton"], groundPushButtonColor);else g_currentMission.guiMenue.guiSetGet:setBackgroundColor(g_currentMission.guiMenue.overlays["groundPushButton"], g_currentMission.guiMenue.default.groundPushButtonColor);end;
		g_currentMission.guiMenue.guiSetGet:setOverlay(self, g_currentMission.guiMenue.overlays["groundPushButton"], buttonType.x, buttonType.y, buttonType.width, buttonType.height);
		g_currentMission.guiMenue.overlays["groundPushButton"]:render();
	end;
	buttonType:render();	
end;

function guiDraw:setClickAreas(x, x1, y, y1, buttonType, whereClick, whatClick, infoTxt, referenceButton, line, button, pullDownLine, helpTxt, maxLine, masterPage, slavePage, pageSide, pageType)
	g_currentMission.guiMenue.clickAreas[#g_currentMission.guiMenue.clickAreas+1] = {
		x; 
		x1;
		y;
		y1;		
		buttonType = tostring(buttonType) or "";
		whereClick = tostring(whereClick) or "";
		whatClick = tostring(whatClick) or "";
		infoTxt = tostring(infoTxt) or "";
		referenceButton = referenceButton or nil;
		line = line or 0;
		button = button or 0;
		pullDownLine = pullDownLine or 0;
		pullDownMaxLine = maxLine or 0;
		helpTxt = tostring(helpTxt) or "";
		masterPage = masterPage or 1;
		slavePage = slavePage or 1;
		pageSide = pageSide or 1;
		pageType = tostring(pageType) or nil;
	};	
end;

