tabletPdaDefaultSide3 = {};
tabletPdaDefaultSide3.tempCmd = {};
function tabletPdaDefaultSide3:generate(installModGuiTablePos, whichPDA, masterPage, slavePage, pageSide)
	----is line/button a pullDownMenue ---> check is pullDownOpen or not --> g_currentMission.guiMenue.master.isPullDownOpen()	
	local isGenerate, errorTxt = true, "";
	function printError()
		if not isGenerate and string.len(tostring(errorTxt)) > 0 then print(tostring(errorTxt));end;
	end;	
	local whichSubPDA = whichPDA or "masterPDA_"
	local lineButtonTable = {};
	local lineCmdTable = {};
	
	--line 1
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "appRefreshCmd_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = 0; 		
		txtOverButton = "Load App Cmds";		
		helpIcon = 0; 
		helpTxt = {};
		infoTxt = "Refresh/Load first App Cmds";
		cmdTable = nil;
		cmdValue = nil;
		cmdType = "stringOnly";
		buttonTxt = "Refresh";
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "appSaveCmd_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = 0; 		
		txtOverButton = "Save App Cmd";		
		helpIcon = 0; 
		helpTxt = {};
		infoTxt = "Check first Cmds for App\nand is Okay then Save/Replace Cmds for App\nis not okay see report";
		cmdTable = nil;
		cmdValue = nil;
		cmdType = "stringOnly";
		buttonTxt = "Check/Replace";
	};	
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=1, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();
	--line 1
	
	--line 2-4, Cmd1-3
	for cmd=1, moGeneralSettings.maxCmd do
		lineCmdTable = {};
		lineButtonTable = {};	
		cmdInt = 1;
		for a=1, #MultiOverlayV3.cmdTable do		
			for cmd=1, #MultiOverlayV3.cmdTable[a].cmd do
				if MultiOverlayV3.cmdTable[a].cmd[cmd].typ ~= "output_" then
					lineCmdTable[cmdInt] = {};
					lineCmdTable[cmdInt].cmdTable = nil;
					lineCmdTable[cmdInt].cmdValue = nil;
					lineCmdTable[cmdInt].cmdType = "stringOnly";
					lineCmdTable[cmdInt].buttonTxt = tostring(MultiOverlayV3.cmdTable[a].cmd[cmd].displayName);		
					lineCmdTable[cmdInt].isSelect = false;
					if MultiOverlayV3.cmdTable[a].cmd[cmd].name == "Empty" then lineCmdTable[cmdInt].isSelect = true;end;
					lineCmdTable[cmdInt].infoTxt = tostring(MultiOverlayV3.cmdTable[a].cmd[cmd].infoTxt);
					lineCmdTable[cmdInt].modOnlyInfo = {cmdTable=a, cmdPos=cmd}; --only for mod alone (to deposit something) -button
					cmdInt = cmdInt+1;
				end;
			end;
		end;
		lineButtonTable[#lineButtonTable+1] = {
			returnClick = "appCmd".. tostring(cmd).. "_";
			isHidden = false; 
			buttonType = 2; 
			buttonWidth = 12; 		
			txtOverButton = "Cmd ".. tostring(cmd); 
			--txtOverButtonColor = moColors.intern["green"];
			helpIcon = 1; 
			helpTxt = {"Not all cmd are multi compatible and support all clicks"};
			infoTxt = "Start a Cmd over PDA App Click";
			cmdTable = lineCmdTable;
			changeAlone = nil; --GuiMenue set new/changes Select or Mod alone set new/changes select then set true (default false or nil)
			cmdValue = nil;
			cmdType = "pullDown_1";		
			buttonTxt = "";
		};
		lineCmdTable = {};
		local tempClick = {"Left", "Middle", "Right", "Key"};
		for a=1, 4 do		
			lineCmdTable[a] = {};
			lineCmdTable[a].cmdTable = nil;
			lineCmdTable[a].cmdValue = nil;
			lineCmdTable[a].cmdType = "stringOnly";
			lineCmdTable[a].buttonTxt = tostring(tempClick[a]);		
			lineCmdTable[a].isSelect = false;		
			if a < 4 then 
				lineCmdTable[a].infoTxt = "Start this Cmd with Mouse Click ".. tostring(tempClick[a]).. "\nNot all cmd are support all Clicks";
			else
				lineCmdTable[a].infoTxt = "Start this Cmd with Key Click (LS Settings)\nNot all cmd are support all Clicks";
			end;
		end;	
		lineButtonTable[#lineButtonTable+1] = {
			returnClick = "appMouseKeyClickCmd".. tostring(cmd).. "_";
			isHidden = false; 
			buttonType = 2; 
			buttonWidth = 0; 		
			txtOverButton = "Click"; 
			--txtOverButtonColor = moColors.intern["green"];
			helpIcon = 1; 
			helpTxt = {"Not all cmd are multi compatible and support all clicks"};
			infoTxt = "Select Mouse/Key Click for Start this Cmd";
			cmdTable = lineCmdTable;
			changeAlone = nil; --GuiMenue set new/changes Select or Mod alone set new/changes select then set true (default false or nil)
			cmdValue = nil;
			cmdType = "pullDown_4";		
			buttonTxt = "";
		};	
		isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=cmd+1, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
		printError();
	end;
	--line 2-4, Cmd1-3
end;

function tabletPdaDefaultSide3:setReturnClick(self, returnClick, whichPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, isVirtualReturnClick) --byName (virtual.... for Activate over Mod(not over Gui Menue click)for set Icons or at GuiMenue or or etc)
	local whichSubPDA = whichPDA or "masterPDA_";
	local upOrLeft = string.find(returnClick, "_Up") or string.find(returnClick, "_Left");
	local downOrRight = string.find(returnClick, "_Down") or string.find(returnClick, "_Right");
	
	local defaultPageSide = 3; --ändern wenn die seite verschoben wird
	
	if string.find(returnClick, "appRefreshCmd_") and not isPullDownOpen then
		tabletPdaDefaultSide3:appCmdTableHidden(whichSubPDA);
		for cmd=1, moGeneralSettings.maxCmd do
			tabletPdaDefaultSide3:refreshCmdTable(whichSubPDA, cmd, true);
		end;		
	elseif string.find(returnClick, "appSaveCmd_") and not isPullDownOpen then
		local errorTxt = "";
		function isMouseKeyClick()
			for cmd=1, #tabletPdaDefaultSide3.tempCmd do
				if tabletPdaDefaultSide3.tempCmd[cmd] ~= nil and string.len(tabletPdaDefaultSide3.tempCmd[cmd].name) > 0 then
					if tabletPdaDefaultSide3.tempCmd[cmd].click.mouseButtonLeft or tabletPdaDefaultSide3.tempCmd[cmd].click.mouseButtonMiddle or tabletPdaDefaultSide3.tempCmd[cmd].click.mouseButtonRight or tabletPdaDefaultSide3.tempCmd[cmd].click.key then
					else
						errorTxt = "Cmd ".. tostring(cmd).. " not select Mouse/Key Click";
						return false;
					end;				
				end;
			end;
			return true;
		end;
		function isMultiple()			
			for cmd=1, #tabletPdaDefaultSide3.tempCmd do
				if tabletPdaDefaultSide3.tempCmd[cmd] ~= nil and string.len(tabletPdaDefaultSide3.tempCmd[cmd].name) > 0 then
					if tabletPdaDefaultSide3.tempCmd[cmd].multiple then
					else
						if cmd > 1 then 
							if string.leng(errorTxt) > 0 then errorTxt = errorTxt.. "\nCmd ".. tostring(cmd).. " not multiple (set alone)";
							else errorTxt = "Cmd ".. tostring(cmd).. " not multiple (set alone)";end;
							return false;
						end;
					end;				
				end;
			end;
			return true;
		end;
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
		local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
		if isSelect then
			--print(DebugUtil.printTableRecursively(tabletPdaDefaultSide3.tempCmd, "tempCmd ", 0, 5))
			if isMouseKeyClick() and isMultiple() then				
				moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].cmd = {};				
				for cmd=1, #tabletPdaDefaultSide3.tempCmd do
					if tabletPdaDefaultSide3.tempCmd[cmd] ~= nil and string.len(tabletPdaDefaultSide3.tempCmd[cmd].name) > 0 then
						moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].cmd[#moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].cmd+1] = {};
						local appCmdTable = moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].cmd[#moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].cmd];
						appCmdTable.name = tostring(tabletPdaDefaultSide3.tempCmd[cmd].name);
						appCmdTable.from = tostring(tabletPdaDefaultSide3.tempCmd[cmd].from);
						appCmdTable.fromRealName = tostring(tabletPdaDefaultSide3.tempCmd[cmd].fromRealName);
						appCmdTable.click = tabletPdaDefaultSide3.tempCmd[cmd].click;												
					end;
				end;
				--tabletPdaDefaultSide3:refreshCmdTable(whichSubPDA, 1, true);
				tabletPdaDefaultSide3:appCmdTableHidden(whichSubPDA);				
				g_currentMission.guiMenue.master.setSaveStatus(MultiOverlayV3.guiMenue.modTable);				
				moSetGetClientSettings:saveConfig(self);
				moSetGetOverlays.infoHelpBox.info.txt = tostring(moSetGetOverlays.pda[whichSubPDA].name).. "\nSaved/Replace all Cmds for\nLine ".. tostring(selectLine).. " App ".. tostring(selectApp);				
			else
				moSetGetOverlays.infoHelpBox.help.txt = errorTxt;
				--g_currentMission:showBlinkingWarning("Found Cmd without select Mouse/Key Click", 2000);
			end;
		end;
	elseif string.find(returnClick, "appCmd1_") and not isPullDownOpen then	
		tabletPdaDefaultSide3:refreshCmdTable(whichSubPDA, 1);
	elseif string.find(returnClick, "appCmd2_") and not isPullDownOpen then	
		tabletPdaDefaultSide3:refreshCmdTable(whichSubPDA, 2);
	elseif string.find(returnClick, "appCmd3_") and not isPullDownOpen then	
		tabletPdaDefaultSide3:refreshCmdTable(whichSubPDA, 3);		
	elseif string.find(returnClick, "appMouseKeyClickCmd1_") or string.find(returnClick, "appMouseKeyClickCmd2_") or string.find(returnClick, "appMouseKeyClickCmd3_") then
		local cmd = 1;
		if string.find(returnClick, "appMouseKeyClickCmd2_") then cmd = 2;elseif string.find(returnClick, "appMouseKeyClickCmd3_") then cmd = 3;end;
		local appCmdButtonPage, appCmdGuiPageTable, appCmdButtonTable, selectPullDownLineCmd = tabletPdaDefaultSide3:getSelectCmd(whichSubPDA, cmd);
		if selectPullDownLineCmd > 1 then
			local modOnlyInfo = appCmdButtonTable.cmdTable[selectPullDownLineCmd].modOnlyInfo;
			local getOrginalCmd = MultiOverlayV3.cmdTable[modOnlyInfo.cmdTable];
			local left, middle, right, key = tabletPdaDefaultSide3:getMouseKeyClickSelect(whichSubPDA, cmd);
			if left and not getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.mouseButtonLeft then left = false;end;
			if middle and not getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.mouseButtonMiddle then middle = false;end;
			if right and not getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.mouseButtonRight then right = false;end;
			if key and not getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.key then key = false;end;
			tabletPdaDefaultSide3:refreshMouseKeyClickSelect(whichSubPDA, cmd, false, left, middle, right, key);
			if tabletPdaDefaultSide3.tempCmd[cmd] ~= nil and string.len(tabletPdaDefaultSide3.tempCmd[cmd].name) > 0 then
				tabletPdaDefaultSide3.tempCmd[cmd].click.mouseButtonLeft = left;tabletPdaDefaultSide3.tempCmd[cmd].click.mouseButtonMiddle = middle;tabletPdaDefaultSide3.tempCmd[cmd].click.mouseButtonRight = right;tabletPdaDefaultSide3.tempCmd[cmd].click.key = key;
			end;
		else
			tabletPdaDefaultSide3:refreshMouseKeyClickSelect(whichSubPDA, cmd, false);
		end;				
	end;	
	return;
end;

function tabletPdaDefaultSide3:refreshCmdTable(whichPDA, cmd, refresh)	
	local whichSubPDA = whichPDA or "masterPDA_";
	local defaultPageSide = 3; --ändern wenn die seite verschoben wird
	local appCmdButtonPage, appCmdGuiPageTable, appCmdButtonTable, selectPullDownLineCmd = tabletPdaDefaultSide3:getSelectCmd(whichSubPDA, cmd);
	local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
	local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
	tabletPdaDefaultSide3.tempCmd[cmd] = {name="", multiple=false, from="", fromRealName="", click={mouseButtonLeft=false, mouseButtonMiddle=false, mouseButtonRight=false, key=false}};
	if isSelect then
		appCmdButtonTable.isHidden = false;
		local appCmdTable = moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp];
		local isLoadOld = appCmdTable.cmd[cmd];
		if isLoadOld and refresh then
			local foundOldCmd = moSetGetCmd:cmdFromReady(nil, appCmdTable.cmd[cmd].name, appCmdTable.cmd[cmd].from, appCmdTable.cmd[cmd].fromRealName);
			if not foundOldCmd then --table.remove(appCmdTable.cmd, cmd); --delte old cmd
				moSetGetGuiMenue:resetSelectPullDownLine(self, nil, nil, appCmdButtonTable, 1);
				tabletPdaDefaultSide3:refreshMouseKeyClickSelect(whichSubPDA, cmd, true);
				moSetGetOverlays.infoHelpBox.info.txt = "Old cmd was found and deleted\n*".. tostring(appCmdTable.cmd[cmd].name).. " from ".. tostring(appCmdTable.cmd[cmd].formRealName);
			else
				local getCmdPos = tabletPdaDefaultSide3:getCmdPullDownLineIsSave(appCmdButtonTable.cmdTable, appCmdTable.cmd[cmd])
				local modOnlyInfo = appCmdButtonTable.cmdTable[selectPullDownLineCmd].modOnlyInfo;
				local getOrginalCmd = MultiOverlayV3.cmdTable[modOnlyInfo.cmdTable];				
				moSetGetGuiMenue:resetSelectPullDownLine(self, nil, nil, appCmdButtonTable, getCmdPos);
				tabletPdaDefaultSide3.tempCmd[cmd] = {name=appCmdTable.cmd[cmd].name, multiple=getOrginalCmd.cmd[modOnlyInfo.cmdPos].multiple, from=appCmdTable.cmd[cmd].from, fromRealName=appCmdTable.cmd[cmd].fromRealName, click={mouseButtonLeft=appCmdTable.cmd[cmd].click.mouseButtonLeft, mouseButtonMiddle=appCmdTable.cmd[cmd].click.mouseButtonMiddle, mouseButtonRight=appCmdTable.cmd[cmd].click.mouseButtonRight, key=appCmdTable.cmd[cmd].click.key}};
				tabletPdaDefaultSide3:refreshMouseKeyClickSelect(whichSubPDA, cmd, false, appCmdTable.cmd[cmd].click.mouseButtonLeft, appCmdTable.cmd[cmd].click.mouseButtonMiddle, appCmdTable.cmd[cmd].click.mouseButtonRight, appCmdTable.cmd[cmd].click.key);
			end;
		elseif selectPullDownLineCmd > 1 then			
			local modOnlyInfo = appCmdButtonTable.cmdTable[selectPullDownLineCmd].modOnlyInfo;
			--print(DebugUtil.printTableRecursively(modOnlyInfo, "modOnlyInfo ", 0, 3))
			local getOrginalCmd = MultiOverlayV3.cmdTable[modOnlyInfo.cmdTable];			
			tabletPdaDefaultSide3.tempCmd[cmd] = {name=getOrginalCmd.cmd[modOnlyInfo.cmdPos].name, multiple=getOrginalCmd.cmd[modOnlyInfo.cmdPos].multiple, from=getOrginalCmd.luaName, fromRealName=getOrginalCmd.realName, click={mouseButtonLeft=getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.mouseButtonLeft, mouseButtonMiddle=getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.mouseButtonMiddle, mouseButtonRight=getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.mouseButtonRight, key=getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.key}};
			tabletPdaDefaultSide3:refreshMouseKeyClickSelect(whichSubPDA, cmd, false, getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.mouseButtonLeft, getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.mouseButtonMiddle, getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.mouseButtonRight, getOrginalCmd.cmd[modOnlyInfo.cmdPos].click.key);
			--print(DebugUtil.printTableRecursively(tabletPdaDefaultSide3.tempCmd, "tempCmd refresh ", 0, 3))
		else
			tabletPdaDefaultSide3:refreshMouseKeyClickSelect(whichSubPDA, cmd, true);
		end;
	end;	
end;

--default
function tabletPdaDefaultSide3:appCmdTableHidden(whichPDA)
	local whichSubPDA = whichPDA or "masterPDA_";
	local defaultPageSide = 3; --ändern wenn die seite verschoben wird	
	local mohPDAs = moSetGetMohPDA:getPDAs();
	if mohPDAs ~= nil and #mohPDAs > 0 then
		for pda=1, #mohPDAs do
			whichSubPDA = mohPDAs[pda][1];
			for cmd=1, moGeneralSettings.maxCmd do
				local appCmdButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="appCmd".. tostring(cmd).. "_", pageGlobalName=whichSubPDA} );
				local appCmdGuiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[appCmdButtonPage.masterPage].page[appCmdButtonPage.slavePage].side[appCmdButtonPage.pageSide];	
				local appCmdButtonTable = Utils.getNoNil(appCmdGuiPageTable.line[appCmdButtonPage.line].button[appCmdButtonPage.button], nil);
				moSetGetGuiMenue:resetSelectPullDownLine(self, nil, nil, appCmdButtonTable, 1);
				appCmdButtonTable.isHidden = true;				
				tabletPdaDefaultSide3:refreshMouseKeyClickSelect(whichSubPDA, cmd, true);				
			end;
		end;
		tabletPdaDefaultSide3.tempCmd = {};
	end;
end;
--default

function tabletPdaDefaultSide3:getCmdPullDownLineIsSave(buttonTable, appCmdTable)
	local selectPullDownLine = 1;
	for a=1, #buttonTable do		
		local cmdTable = MultiOverlayV3.cmdTable[buttonTable[a].modOnlyInfo.cmdTable];
		if cmdTable ~= nil and cmdTable.cmd[buttonTable[a].modOnlyInfo.cmdPos].name == appCmdTable.name and cmdTable.luaName == appCmdTable.from and cmdTable.realName == appCmdTable.fromRealName then selectPullDownLine = a;break;end; 
	end;	
	return selectPullDownLine;
end;

function tabletPdaDefaultSide3:getSelectCmd(whichPDA, cmd)
	local whichSubPDA = whichPDA or "masterPDA_";
	local defaultPageSide = 3; --ändern wenn die seite verschoben wird
	local appCmdButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="appCmd".. tostring(cmd).. "_", pageGlobalName=whichSubPDA} );
	local appCmdGuiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[appCmdButtonPage.masterPage].page[appCmdButtonPage.slavePage].side[appCmdButtonPage.pageSide];	
	local appCmdButtonTable = Utils.getNoNil(appCmdGuiPageTable.line[appCmdButtonPage.line].button[appCmdButtonPage.button], nil);
	return appCmdButtonPage, appCmdGuiPageTable, appCmdButtonTable, moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, appCmdButtonTable);
end;

function tabletPdaDefaultSide3:refreshMouseKeyClickSelect(whichPDA, cmd, setHidden, left, middle, right, key)
	local whichSubPDA = whichPDA or "masterPDA_";
	local defaultPageSide = 3; --ändern wenn die seite verschoben wird
	local mouseClickButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="appMouseKeyClickCmd".. tostring(cmd).. "_", pageGlobalName=whichSubPDA} );
	local mouseClickGuiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[mouseClickButtonPage.masterPage].page[mouseClickButtonPage.slavePage].side[mouseClickButtonPage.pageSide];	
	local mouseClickButtonTable = Utils.getNoNil(mouseClickGuiPageTable.line[mouseClickButtonPage.line].button[mouseClickButtonPage.button], nil);
	if setHidden then mouseClickButtonTable.isHidden = true;else mouseClickButtonTable.isHidden = false;end;
	mouseClickButtonTable.cmdTable[1].isSelect = left or false;
	mouseClickButtonTable.cmdTable[2].isSelect = middle or false;
	mouseClickButtonTable.cmdTable[3].isSelect = right or false;
	mouseClickButtonTable.cmdTable[4].isSelect = key or false;
end;

function tabletPdaDefaultSide3:getMouseKeyClickSelect(whichPDA, cmd)
	local whichSubPDA = whichPDA or "masterPDA_";
	local defaultPageSide = 3; --ändern wenn die seite verschoben wird
	local mouseClickButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="appMouseKeyClickCmd".. tostring(cmd).. "_", pageGlobalName=whichSubPDA} );
	local mouseClickGuiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[mouseClickButtonPage.masterPage].page[mouseClickButtonPage.slavePage].side[mouseClickButtonPage.pageSide];	
	local mouseClickButtonTable = Utils.getNoNil(mouseClickGuiPageTable.line[mouseClickButtonPage.line].button[mouseClickButtonPage.button], nil);
	return mouseClickButtonTable.cmdTable[1].isSelect, mouseClickButtonTable.cmdTable[2].isSelect, mouseClickButtonTable.cmdTable[3].isSelect, mouseClickButtonTable.cmdTable[4].isSelect;
end;